{$V-}
unit appmain;
interface
uses ASS,DOS,Detect,Ruschar,Utils,A_Play,Collect,
 APP,DIALOGS, DRIVERS,
 HISTLIST, MEMORY,MENUS,
 MSGBOX,OBJECTS, STDDLG,
 VIEWS,AppConst,AppDlgs,MenuStatus;

type
PMyWin=^TMyWin;
PMainApp=^TMainApp;

TMainApp=object(TApplication)
CurWin:byte;
WinList:array[0..9]of PMyWin;
Constructor Init;
Destructor Done;Virtual;
Procedure   InitMenuBar;Virtual;
Procedure   InitStatusLine;Virtual;
Procedure   HandleEvent(var E:TEvent);virtual;
Function    Valid(Command:word):boolean;Virtual;
Procedure   SaveForDOSShell;
Procedure   MyDosShell;Virtual;
Procedure   Call006;virtual;
Procedure   Idle;Virtual;
Procedure   CloseAll;
Procedure   OptionsFile;
Procedure   OptionsEdit;
Procedure   OptionsPlay;
Procedure   OptionsPref;
Procedure   OptionsMouse;
Procedure   SaveConfig;
Procedure   SaveConfigAs;
Procedure   OpenConfig;
Function    InvalidAnnFile(var F:File;var Bl,Sz,HLen:word):boolean;
Function    InvalidComFile(var F:file;var sz:word):boolean;
Function    LoadAnn:boolean;
Function    LoadCom:boolean;
Function    LoadSnd:boolean;
Function    SaveAnn:boolean;
Function    SaveAs :boolean;
Procedure   SaveAll;
Procedure   WriteCom;
Procedure   PlayAll;
Procedure   PlayOnDisplay;
Procedure   OpenNew(Nm:FNameStr);
Procedure   CreateNew;
end;


Pinterior=^TInterior;
TInterior=object(TScroller)
MColl:PMyColl;
WinOwner:PMyWin;
Constructor Init(Bounds:Trect;HS,VS:PScrollBar;WOwner:PMyWin);
Procedure HandleEvent(var E:TEvent);Virtual;
Procedure Draw;virtual;
Function  GetPalette:PPalette;virtual;
end;


TMyWin=object(TWindow)
Num:Byte;
MColl:PMyColl;
Name,{File Name}
Header:Pstring;
CurPos,CurPart,
upLine,dnLine:word;
MainOwner:PMainApp;
Interior:PInterior;
WinComSet:TCommandset;
Modified,
Playing:boolean;
Cur8:Save8Type;
Constructor Init(Bounds:TRect;Id:word;Flname:FNameStr;PM:PMainApp);
Destructor Done;Virtual;
Procedure HandleEvent(var E:TEvent);Virtual;
Function  Valid(Command:word):boolean;virtual;
Procedure Draw;Virtual;
Function  GetPalette:PPalette;Virtual;
Procedure CurrentPart(N:word);
Procedure MarkPart(p1,p2:word;stat:boolean;bitblt:byte);
Procedure UnMarkAll;
Procedure EditHeader;
Procedure EditTransp;
Procedure EditTemp;
Procedure EditCopy;
Procedure EditCut;
Procedure EditClear;
Procedure EditPaste;
Procedure PlayFrom;
Procedure MakeCurrent;
Procedure ReleaseCurrent;
Procedure SetMyWinCommands;
end;


TWordArray=array[0..32766]of word;
PWordArray=^TWordArray;
TByteArray=array[0..65534]of byte;
PByteArray=^TByteArray;


SOptFileRec=record
            BytesWrAnn,
            BytesWrCom:Word;
            kbComStop,
            WrHeader,
            OpenIntoEmpty_:Byte;
            end;

SOptEditRec=record
            tmpincr:word;
            MarkMovesDown:WordBool;
            TempChangeAll,
            TranspChangeAll:byte;
            end;

SOptPlayRec=record
            BytesToPlay:word;
            POTMDiv,POTRMult:real;
            AutoSetup,
            Blinking,Display_Time,Locks_Lit:boolean;
            end;

SOptPrefRec=record
            AutoSaveReturn,
            ScrMode:word;
            end;

SOptMouseRec=record
            DblDelay:word;
            Reverse:boolean
            end;

OptSaveRec=record
           ChkSum:word;
           FileOpt:SOptFileRec;
           EditOpt:SOptEditRec;
           PlayOpt:SOptPlayRec;
           PrefOpt:SOptPrefRec;
           MouseOpt:SOptMouseRec;
           Test:word;
           end;

const SwapFileName:FNameStr='007.SWP';

var StartDirectory:FNameStr;
    _006Tempfile:FNameStr;
    _006ParamStr:string[127];
    _IsRunning006:boolean;
    _006_SwapFileName:ComStr;
    OldCode:array[1..5]of byte;
    DelFileProc:Pointer;

Procedure DoneAll;
Procedure InitAll;
{Procedure WriteExitMsg;}
Procedure EraseFile(S:FNameStr);
implementation

const WordEditCache:PWordArray=Nil;
      IsToCorrectTime:boolean=False;
      PlayingOnScreen:boolean=False;
var PointerEditCache:Pointer absolute WordEditCache;
    ByteEditCache:PByteArray absolute WordEditCache;
{ ।. ଠ : - ⥩;
                         DatSize   ;
                         Special   ;
                         ⢥ 
}
    OldEnvSeg :word;
    NewEnvSeg :word;
    NewEnvSize:word;

Procedure DoneAll;
Begin
DoneRusChars;
DoneSysError;
DoneEvents;
DoneVideo;
DoneMemory;
if not _IsRunning006 then begin ASS.T.RestoreScreen;ASS.T.Done end
                     else if IsKeyrus then PrintStr(Run006MsgStr)
                                      else PrintStr(Run006MsgStr1);
SetMemTop(HeapPtr);
end;

Procedure InitAll;
Begin
SetMemTop(HeapEnd);
if not _IsRunning006 then
  begin
  ASS.T.Init;ASS.T.SaveScreen;
  word(ptr(prefixseg,$2C)^):=OldEnvSeg;
  freemem(ptr(NewEnvSeg,0),NewEnvSize);
  end;
InitMemory;
InitVideo;
InitEvents;
InitSysError;
Application^.Redraw;
if not IsKeyRus then begin InitRusChars;ShowMouse end;
end;

{Procedure WriteExitMsg;
begin
if IsKeyrus then PrintStr(DosExitText)
            else PrintStr(DosExitText1)
end;}

Procedure EraseFile;
var f:file;
begin
if s='' then exit;
Assign(f,s);
Erase(f);
byte(s[length(s)+1]):=ioresult;
end;



Function MySysError(ErrorCode:integer;Drive:Byte):Integer;Far;Forward;

Function WriteSettings(s:string):boolean;
var Opt:OptSaveRec;
    P:PByteArray;
    I:word;
    F:File;
Begin
WriteSettings:=False;
if s='' then begin WriteSettings:=True;exit end;
P:=@Opt.FileOpt;
with Opt do
     begin
     with FileOpt do begin
                     BytesWrAnn:=BytesWrite;
                     BytesWrCom:=BytesWriteCom;
                     kbComStop:=kbStopCom;
                     WrHeader:=WriteHeader;
                     OpenIntoEmpty_:=OpenIntoEmpty;
                     end;
     with EditOpt do begin
                     TmpIncr:=TempIncr;
                     MarkMovesDown:=MarkDown;
                     TempChangeAll:=TMChangeAll;
                     TranspChangeAll:=TRChangeAll
                     end;
     with PlayOpt do begin
                     BytesToPlay:=BytesPlay;
                     POTMDiv:=PlayScreenTempDivisor;
                     POTRMult:=PlayScreenTranspMultiplicator;
                     AutoSetup:=AutoSetupTemp;
                     Blinking:=BlinkingChars;
                     Display_Time:=DisplayTime;
                     Locks_Lit:=LocksLit;
                     end;
     with PrefOpt do begin
                     ScrMode:=ScreenMode;
                     AutoSaveReturn:=ord(AutoSaveConfig)shl 2+
                                     ord(ReturnStartDir)shl 1+
                                     ord(AutoSaveFiles);
                     end;
    with MouseOpt do begin
                     DblDelay:=DoubleDelay;
                     Reverse:=MouseReverse;
                     end;
     Test:=$ABCD;
     ChkSum:=0;
{$Q-}
     for i:=0 to Sizeof(Opt)-Sizeof(ChkSum)-1 do
      ChkSum:=ChkSum+P^[i];
     End;
Assign(F,S);
{$I-}
rewrite(f,1);
if Ioresult<>0 then exit;
BlockWrite(F,Opt,Sizeof(Opt),I);
Close(F);
if I<>Sizeof(Opt) then exit;
WriteSettings:=True;
End;


Function ReadSettings(s:string):boolean;
var Opt:OptSaveRec;
    P:PByteArray;
    I,J:word;
    F:File;
Begin
if s='' then begin ReadSettings:=True;exit end;
ReadSettings:=False;
Assign(F,s);
{$I-}
Reset(f,1);
fileMode:=0;
if ioresult<>0 then exit;
Blockread(f,Opt,Sizeof(Opt),i);
close(f);
if i<>Sizeof(Opt) then exit;
P:=@Opt.FileOpt;
with Opt do
     begin
     if Test<>$ABCD then exit;
     J:=0;
     for i:=0 to Sizeof(Opt)-Sizeof(Opt.ChkSum)-1 do
       J:=J+P^[i];
     if J<>ChkSum then exit;
     if(FileOpt.wrheader>2)or
       (FileOpt.kbComStop>2)or
       (EditOpt.TmpIncr>Maxtemp)or
       (PlayOpt.BytesToPlay>PlayLimit)or
       (PrefOpt.ScrMode>smMono+smFont8x8)or
       (PrefOpt.AutoSaveReturn>7)then exit;
     with FileOpt do begin
                     BytesWrite:=BytesWrAnn;
                     BytesWriteCom:=BytesWrCom;
                     kbStopCom:=kbComStop;
                     WriteHeader:=WrHeader;
                     OpenIntoEmpty:=OpenIntoEmpty_;
                     end;
     with EditOpt do begin
                     TempIncr:=TmpIncr;
                     MarkDown:=MarkMovesDown;
                     TMChangeAll:=TempChangeAll;
                     TRChangeAll:=TranspChangeAll
                     end;
     with PlayOpt do begin
                     BytesPlay:=BytesToPlay;
                     PlayScreenTempDivisor:=POTMDiv;
                     PlayScreenTranspMultiplicator:=POTRMult;
                     AutoSetupTemp:=AutoSetup;
                     DisplayTime:=Display_Time;
                     BlinkingChars:=Blinking;
                     LocksLit:=Locks_Lit;
                     end;
     with PrefOpt do begin
                     if ScrMode<>screenmode then
                       with Application^ do
                        begin
                        SetScreenMode(ScrMode);
                        Redraw;
                        if not IsKeyRus then InitRusChars;
                        ShowMouse;
                        end;
                     AutoSaveConfig:=(AutoSaveReturn and 4)<>0;
                     ReturnStartDir:=(AutoSaveReturn and 2)<>0;
                     AutoSaveFiles :=(AutoSaveReturn and 1)<>0;
                     end;
    with MouseOpt do begin
                     DoubleDelay:=DblDelay;
                     MouseReverse:=Reverse;
                     end;
     End;
ReadSettings:=True;
End;

Constructor TMainApp.Init;
var i:word;
    n:byte;
    s:FnameStr;
    dir:dirstr;
    nam:namestr;
    ext:extstr;
    p:PString;
Begin
Inherited Init;
ShowMouse;
if UnderWin and(MessageBox(emWindowsDetected,nil,mfWarning or mfYesNo)<>cmYes)
  then Fail;
if IsDV and(MessageBox(emDVDetected,nil,mfWarning or mfYesNo)<>cmYes)
  then Fail;
EnableKbHandler:=True;
if not IsKeyRus then InitRusChars;
ShowMouse;
CurWin:=0;
FillChar(WinList,sizeof(winList),0);
_006Tempfile[0]:=#0;
_006ParamStr[0]:=#0;
fillChar(OldCode,Sizeof(OldCode),0);
GetDir(0,StartDirectory);
ChangeProc(@MsgBox.MessageBox,@AppDlgs.MessageBox);
SysErrorFunc:=MySysError;
s:='';
if FileExists(CfgName)then s:=FExpand(CfgName);
if s=''then begin
            fsplit(Progname,dir,nam,ext);
            if FileExists(Dir+ConfigName)then s:=Dir+ConfigName;
            end;
if Not ReadSettings(s)then MessageBox(emInvalidConfig,Nil,mfError or mfOkButton);
upstring(s);
if s<>''then ConfigName:=s;
Blinking(EnableBlinking);
if Not MouseEvents then MyPlay:=OrgPlay;
upstring(CmdLnPtr^);
if ParamCount>0 then
for i:=1 to paramcount do
begin
s:=paramstr(i);
n:=length(s);
while(s[n]<>'.')and(n>0)do dec(n);
if(n=0)or(n+3<length(s))then s:=s+AnnExt;
if(pos('*',s)<>0)or(pos('?',s)<>0)or(ValidFileName(s))
then OpenNew(FExpand(s))
end             else
{if ExecuteDialog(New(PAboutDialog,Init),Nil)<>cmNo{ "=cmOk" then} CreateNew;
End;

Destructor TMainApp.Done;
Begin
if ReturnStartDir then ChDir(StartDirectory);
if AutoSaveConfig then if not WriteSettings(ConfigName)then MessageBox(emErrorSavingConfig,Nil,mfError or mfOkButton);
DoneRusChars;
Inherited Done;
End;

Procedure   TMainApp.InitMenuBar;
var R:TRect;
Begin
GetExtent(R);
with R do B.Y:=succ(A.Y);
MenuBar:=MyMenuBar(R)
END;

Procedure TMainApp.InitStatusLine;
var R:TRect;
Begin
GetExtent(R);
with R do A.Y:=pred(B.Y);
Statusline:=MyStatusLine(R);
DisableCommands(DisIniComSet);
EnableCommands(EnIniComSet);
if ButtonCount<>0 then EnableCommands([cmOptMouse])
End;

Procedure   TMainApp.SaveForDOSShell;
var I,j,k:byte;
Begin
if AutoSaveFiles then begin
                      I:=CurWin;
                      for j:=1 to 9 do if WinList[j]<>Nil then
                          begin
                          CurWin:=j;
                          k:=Helpctx;
                          Helpctx:=hcSaving;
                          if winlist[j]^.name=nil
                            then ReadWriteName:=''
                            else ReadWriteName:=winlist[j]^.name^;
                          StatusLine^.Update;
                          if WinList[j]^.Modified then
                          WinList[j]^.Modified:=not SaveAnn;
                          Helpctx:=k;
                          StatusLine^.Update;
                          end;
                      CurWin:=I
                      end;
if AutoSaveConfig then if not WriteSettings(ConfigName)then MessageBox(emErrorSavingConfig,Nil,mfError or mfOkButton);
end;

Procedure TMainApp.MyDosShell;
var i,k,n:word;
    s,s1:string;
    p,q:PByteArray;
begin
SaveForDOSShell;
if IsKeyRus then s:=DosExitPrompt
            else s:=DosExitPrompt1;
s1:=getenv('PROMPT');
if s1<>'' then
begin
i:=word(ptr(prefixseg,$2C)^);
p:=ptr(i,0);
s1[0]:=char(sizeof(s1)-1);
move(p^,s1[1],sizeof(s1)-1);
n:=pos('PROMPT',s1);
inc(n,length('PROMPT'));
for k:=0 to 500 do if(p^[k]=0)and(p^[k+1]=0)then break;
if k<500 then
begin
inc(k,2);
i:=p^[k];
for i:=1 to i do begin inc(k);repeat inc(k) until p^[k]=0 end;
i:=length(getenv('PROMPT'));
NewEnvSize:=k-i+length(s);
q:=MemAllocSeg(NewEnvSize);
move(p^,q^,n);
move(s[1],q^[n],length(s));
move(p^[n+i],q^[n+length(s)],k-(n+i));
OldEnvSeg:=seg(p^);
NewEnvSeg:=seg(q^);
word(ptr(prefixseg,$2C)^):=NewEnvSeg;
end
end;
_IsRunning006:=False;
end;



Procedure TMainApp.Call006;
var f,t:file;
    parthdr:record partpg,pgcnt:word end;
function GetTailSize:longint;
var l:longint;
    n:byte;
begin
GetTailSize:=-1;
if progname='' then exit;
assign(f,progname);
n:=filemode;
filemode:=0;
reset(f,1);
filemode:=n;
seek(f,2);
blockread(f,parthdr,sizeof(parthdr));
if ioresult<>0 then begin close(f);exit end;
l:=filesize(f);
close(f);
with parthdr do l:=l-((Longint(pgcnt-1)*512)+partpg);
GetTailSize:=l;
end;
var n:byte;
    w:word;
    k,l,m:longint;
    s:FNameStr;
    buf:pwordarray;
    bufsize,numread,numwritten:word;
    RelItem:record I_Ofs,I_Seg:word end;
    Tbl_ofs,ReloCnt,C_Seg,C_Ofs:word;
begin
l:=GetTailSize;
if l=0 then begin MessageBox(emNoExecutableTail,nil,mfError or mfOkButton);exit end;
if l=-1 then exit;
if UnderWin or IsDV then _006Tempfile:='';
m:=Longint(Seg(HeapPtr^))*16+ofs(HeapPtr^)-Longint(PrefixSeg)*16;
if XMSFree<m then m:=m+l else m:=l;

if _006Tempfile='' then
begin
getdir(0,s);
if s[byte(s[0])]<>'\' then s:=s+'\';
if(DiskFree(0)>m)and(ValidFileName(s+tempexename))then
       begin _006Tempfile:=s+tempexename;
             _006_SwapFileName:=s+SwapFileName;
       end;
end;
k:=m-1;
if _006Tempfile='' then
for n:=byte('C')to byte(getmaxdrive) do
  if GetDriveType(n-64)=Drive_Fixed then
     begin
     if k>=DiskFree(n-64) then continue;
     getdir(n-64,s);
     if s[byte(s[0])]<>'\' then s:=s+'\';
     if(ValidFileName(s+tempexename))then
       begin _006Tempfile:=s+tempexename;
             _006_SwapFileName:=s+SwapFileName;
             break;
       end;
     end;
if _006Tempfile='' then
       begin
       {m:=(l+(Longint(Seg(HeapPtr^))*16+ofs(HeapPtr^)-Longint(PrefixSeg)*16))div 1000+1;}
       m:=(m div 1000)+1;
       buf:=@m;
       MessageBox(emNoSpaceForTempFile,buf,mfInformation or mfOkButton);
       exit end;
if l<maxbufsize then bufsize:=l else bufsize:=maxbufsize;
if maxavail<bufsize then bufsize:=maxavail;
if bufsize<512 then begin exit end;
getmem(buf,bufsize);
n:=filemode;
filemode:=0;
assign(t,_006Tempfile);
rewrite(t,1);
assign(f,progname);
reset(f,1);
filemode:=n;
m:=filesize(f)-l;
seek(f,m);
numwritten:=0;
w:=HelpCtx;
HelpCtx:=hcExtracting006;
PlayName:=Copy(_006Tempfile,0,2);
StatusLine^.Update;
repeat
blockread (f,buf^,bufsize,numread);
if Numwritten=0 then begin
                     numwritten:=Buf^[0];
                     move(Buf^[1],parthdr,sizeof(parthdr));
                     with parthdr do m:=((Longint(pgcnt-1)*512)+partpg);
                     if NumWritten=$5A4D then m:=l-m else m:=-1;
                     if m<0 then break;
                     end;
if numread<>0 then
blockwrite(t,buf^,numread,numwritten);
until(numread=0)or(numwritten<>numread);
close(f);
freemem(buf,bufsize);
if m<0 then begin close(t);erase(t);MessageBox(emBadExecutableTail,nil,mfError or mfOkButton);_006Tempfile:=''; exit end;
seek(t,0);
getmem(buf,28);
blockread(t,Buf^,28);
seek(t,Buf^[12]);
C_Seg:=Buf^[11];C_Ofs:=Buf^[10];
M:=Buf^[4]*16;
k:=longint(C_Seg)*16+C_Ofs;
freemem(Buf,28);
repeat
blockread(t,RelItem,Sizeof(Relitem));
with RelItem do
 if(longint(I_Seg)*16+I_Ofs)>=k then
 if(I_seg<>C_Seg)or(I_Ofs-(5+2)>=C_ofs)then{Look for 5 bytes between relocation items in EXE-file}
 begin
 inc(M,Longint(C_Seg)*16);
 inc(M,C_Ofs+2);
 Seek(t,M);
 BlockRead(t,OldCode,Sizeof(OldCode));
 n:=$9A;{FAR CALL}
 seek(t,M);
 BlockWrite(t,n,1);
 BlockWrite(t,DelFileProc,4);{Adress}
 M:=0;
 end
 else begin C_Seg:=I_Seg;C_Ofs:=I_Ofs end;
until(InOutRes<>0)or(M=0);
PChar(Buf):=PChar(DelFileProc)+3;{(3 bytes)JMP XXXX instruction}
move(OldCode,Buf^,5);
PChar(Buf):=PChar(DelFileProc)+3+5;
move(_006Tempfile[1],Buf^,length(_006Tempfile));
PChar(Buf):=PChar(Buf)+length(_006Tempfile);
byte(pointer(Buf)^):=0;
close(t);
HelpCtx:=w;
StatusLine^.Update;
n:=ioresult;
SaveForDOSShell;
_IsRunning006:=True;
end;

Procedure TMainApp.HandleEvent(var E:TEvent);
var I:word;
    MsgHandled:boolean;
Begin
MsgHandled:=True;
If E.What = evCommand then
begin
Case E.Command Of
cmChangeDir:begin ChangeDir;if WinList[CurWin]<>Nil then WinList[CurWin]^.DrawView end;
cmDosShell:MyDosShell;
cmEditRun006:Call006;
cmTile:Tile;
cmCascade:Cascade;
cmCloseAll:CloseAll;
cmSaveAll:SaveAll;
cmOptFile:OptionsFile;
cmOptEdit:OptionsEdit;
cmOptPlay:OptionsPlay;
cmOptPrefer:OptionsPref;
cmOptMouse:OptionsMouse;
cmOptSave:SaveConfig;
cmOptSaveAs:SaveConfigAs;
cmOptOpen:OpenConfig;
cmNew:CreateNew;
cmOpen:OpenNew('');
cmplayAll:begin
          I:=HelpCtx;
          HelpCtx:=hcPlayingAll;
          if(WinList[CurWin]<>Nil)and(WinList[CurWin]^.Title<>Nil)then
          PlayName:=StripTitle(WinList[CurWin]^.Title^)           else
          PlayName:='';
          StatusLine^.Update;
          PlayAll;
          HelpCtx:=I
          end;
cmPlayOnScreen:PlayOnDisplay
else MsgHandled:=False
end;
if MsgHandled then ClearEvent(E)
end;
i:=0;
If E.What = evBroadCast then
Case E.Command Of
cmReceivedFocus:if(E.InfoPtr=MenuBar)then
                  begin DisposeStr(SaveCfgMenuItemPtr^.Param);
                        SaveCfgMenuItemPtr^.Param:=NewStr(StripFileName(ConfigName));
                  end;
end;
Inherited HandleEvent(E);
End;

Function TMainApp.Valid(Command:word):boolean;
var b:boolean;
    I,j:byte;
begin
if Command=0 then begin Valid:=True; exit end;
B:=True;
j:=curwin;
if(Command=cmQuit)or(Command=cmClose)then
for I:=1 to 9 do if B and(WinList[i]<>Nil)then
                    begin
                    CurWin:=i;
                    if WinList[i]^.Focus then
                    B:=B and WinList[i]^.Valid(cmClose);
                    end;
CurWin:=j;
Valid:=B
End;

Procedure TMainApp.OptionsFile;
var PD:POptFileDialog;
    DR:OptFileRec;
    I:word;
    Code:integer;
Begin
str(BytesWrite div 6,Dr.AccWriteAnn);
str(BytesWriteCom div 6,Dr.AccWriteCom);
Dr.kbComStop:=kbStopCom;
Dr.WriteHeader:=WriteHeader;
Dr.OpenIntoEmpty:=OpenIntoEmpty;
PD:=New(POptFileDialog,Init);
if ExecuteDialog(PD,@DR)=cmOk
then begin
     val(Dr.AccWriteAnn,I,Code);
     if code=0 then BytesWrite:=I*6;
     val(Dr.AccWriteCom,I,Code);
     if code=0 then BytesWriteCom:=I*6;
     kbStopCom:=Dr.kbComStop;
     WriteHeader:=Dr.WriteHeader;
     OpenIntoEmpty:=Dr.OpenIntoEmpty;
     end
End;

Procedure TMainApp.OptionsEdit;
var PD:POptEditDialog;
    DR:OptEditRec;
    I:word;
    Code:integer;
Begin
str(TempIncr,Dr.TempIncr);
dr.MarkMovesDown:=MarkDown;
dr.TMChangeAll:=TMChangeAll;
dr.TRChangeAll:=TRChangeAll;
PD:=New(POptEditDialog,Init);
if ExecuteDialog(PD,@DR)=cmOk
then begin
     val(Dr.TempIncr,I,Code);
     if code=0 then TempIncr:=I;
     MarkDown:=Dr.MarkMovesDown;
     TMChangeAll:=dr.TMChangeAll;
     TRChangeAll:=dr.TRChangeAll;
     end
End;



Procedure TMainApp.OptionsPlay;
var PD:POptPlayDialog;
    DR:OptPlayRec;
    I:word;
    Code:integer;
    R:Real;
    s:string[10];
Begin
str(BytesPlay div 6,Dr.AccCnt);
str(PlayScreenTempDivisor:1:3,s);
if Length(s)>sizeof(OptPlayStr1)-1 then s[0]:=chr(sizeof(OptPlayStr1)-1);
dr.POTMDiv:=s;
str(PlayScreenTranspMultiplicator:1:3,s);
if Length(s)>sizeof(OptPlayStr1)-1 then s[0]:=chr(sizeof(OptPlayStr1)-1);
dr.POTRMult:=s;
dr.AutoSetup:=ord(AutoSetupTemp)or(ord(DisplayTime)shl 1)or(ord(LocksLit)shl 2);
dr.Blinking:=BlinkingChars;

PD:=New(POptPlayDialog,Init);
if ExecuteDialog(PD,@DR)=cmOk
then begin
     val(Dr.AccCnt,I,Code);
     if(code=0)and(I<>0)then if(I*6<=PlayLimit)then BytesPlay:=I*6 else I:=PlayLimit;
     val(dr.POTMDiv,r,code);
     if(code=0)and(r<>0)then PlayScreenTempDivisor:=r;
     val(dr.POTRMult,r,code);
     if(code=0)and(r<>0)then PlayScreenTranspMultiplicator:=r;
     AutoSetupTemp:=dr.AutoSetup and 1<>0;
     DisplayTime:=dr.AutoSetup and 2<>0;
     LocksLit:=dr.AutoSetup and 4<>0;
     BlinkingChars:=dr.Blinking;
     end
End;


Procedure TMainApp.OptionsPref;
var PD:POptPrefDialog;
    DR:OptPrefPrefRec;
    I:Word;
Begin
Dr.ScreenRes:=Hi(ScreenMode);
Dr.AutoSaveReturn:=(Ord(AutoSaveConfig)shl 2)+(Ord(ReturnStartDir)shl 1)+Ord(AutoSaveFiles);
case Lo(ScreenMode) of
smBW80:Dr.ScrMode:=1;
smCO80:Dr.ScrMode:=0;
smMono:Dr.ScrMode:=2
end;


New(PD,Init);
if ExecuteDialog(PD,@Dr)=cmOk then
   begin
   case Dr.ScrMode of
   0:begin i:=smCO80;AppPalette:=apColor end;
   1:begin i:=smBW80;AppPalette:=apBlackWhite end;
   2:begin i:=smMono;AppPalette:=apMonochrome end
   end;
   I:=(dr.ScreenRes shl 8)+I;
   if i<>screenmode then begin setscreenMode(I);
                               Blinking(EnableBlinking);
                               if not IsKeyRus then InitRusChars;
                               redraw;
                               ShowMouse;
                         end;
   AutoSaveFiles:=(Dr.AutoSaveReturn and 1)<>0;
   ReturnStartDir:=(Dr.AutoSaveReturn and 2)<>0;
   AutoSaveConfig:=(Dr.AutoSaveReturn and 4)<>0;
   end
End;


Procedure TMainApp.OptionsMouse;
var PM:PMouseDialog;
Begin
New(PM,Init);
ExecuteDialog(PM,@MouseReverse);
End;

Procedure TMainApp.SaveConfig;
Begin
if ConfigName='' then begin SaveConfigAs;exit end;
if not WriteSettings(ConfigName)then MessageBox(emErrorSavingConfig,Nil,mfError or mfOkButton);
End;

Procedure TMainApp.SaveConfigAs;
var S:string;
    i:word;
Begin
s:=FExpand('');
i:=1;
while s[i]=ConfigName[i]do inc(i);
s:=copy(ConfigName,i,length(ConfigName));
ChooseStr:=ChooseStr5;
GetFileName(s,ConfigExt);
if s='' then exit;
if not WriteSettings(s)then MessageBox(emErrorSavingConfig,Nil,mfError or mfOkButton)
else ConfigName:=S
end;

Procedure TMainApp.OpenConfig;
var S:string;
    i:word;
Begin
s:=FExpand('');
i:=1;
while s[i]=ConfigName[i]do inc(i);
s:=copy(ConfigName,i,length(ConfigName));
ChooseStr:=ChooseStr6;
GetFileName(s,ConfigMask);
if s='' then exit;
if not ReadSettings(s)then MessageBox(emInvalidConfig,Nil,mfError or mfOkButton)
else ConfigName:=S
end;


Procedure TMainApp.CloseAll;
var I:word;
Begin
For I:=1 to 9 do if WinList[I]<>Nil then WinList[I]^.Close
End;

procedure GetTime(var Hour, Minute, Second, Sec100: Word);
var a:shortint;
begin
asm
       mov   al,0
       out   70h,al
       mov   cx,DelCnt
@@1:   nop
       loop  @@1
       in    al,71h
       mov   a,al
end;
if a<0 then Dos.GetTime(Hour, Minute, Second, Sec100)
else begin
     asm
       mov   ax,0
{       out   70h,al
       mov   cx,DelCnt
@@1:   nop
       loop  @@1
       in    al,71h
       les   di,Second
       stosw}
       mov   al,2
       out   70h,al
       mov   cx,DelCnt
@@2:   nop
       loop  @@2
       in    al,71h
       les   di,minute
       stosw
       mov   al,4
       out   70h,al
       mov   cx,DelCnt
@@3:   nop
       loop  @@3
       in    al,71h
       les   di,hour
       stosw
       end;
       Hour:=BCDtoDec(Hour);
       Minute:=BCDtoDec(Minute);
       Second:=BCDtoDec(word(a));
       Sec100:=0{round((Memw[Seg0040:$6C] mod 18)*100/18)};
       end;
end;


Procedure TMainApp.Idle;
var GT:Boolean;
function LeadingZeroStr(a:word):string;
var s:string;
begin
str(a,s);
if length(s)<2 then s:='0'+s;
GT:=s[0]<#3;
LeadingZeroStr:=s
end;
var s:string[14];
    Hour, Minute, Second, Sec100: Word;
Begin
if PlayingOnScreen then exit;
Inherited Idle;
if(Winlist[CurWin]=Nil)or(not Winlist[CurWin]^.Playing)or DisplayTime then
begin
GetTime(Hour, Minute, Second, Sec100);
{if Sec100<50 then s:=LeadingZeroStr(Hour)+'.'+LeadingZeroStr(Minute)+':'+LeadingZeroStr(second)
             else s:=LeadingZeroStr(Hour)+'.'+LeadingZeroStr(Minute)+' '+LeadingZeroStr(second);}
s:=LeadingZeroStr(Hour)+':'+LeadingZeroStr(Minute)+':'+LeadingZeroStr(second);
if IsRus and not HiResScreen then s:='  RUS '+s else s:='    '+s;
outstringxy(s,ScreenWidth-length(s),1,byte(getpalette^[2]),0);
end;
if(Winlist[CurWin]<>Nil)then
  if(Winlist[CurWin]^.Playing)then IsToCorrectTime:=True
                              else
  if IsToCorrectTime and GT then
  begin
  IsToCorrectTime:=False;
  SetTime(Hour, Minute, Second, Sec100);
  end;
end;

{$I-}
Function TMainApp.InvalidAnnFile(var F:File;var Bl,Sz,HLen:word):boolean;
var c,w:word;
    b:byte;
    p,l:longint;
    ior:integer;
begin
invalidAnnFile:=true;
p:=filepos(F);
if ioresult<>0 then exit;
seek(f,0);
l:=filesize(f);
if l<=3+1+2 then exit;
blockread(f,b,1);
if b>l then exit;
HLen:=b;
seek(f,filepos(f)+b+8);
l:=(l-b)-1-sizeof(save8type);
c:=0;
sz:=0;
repeat
blockread(f,w,2);
inc(sz,w);
if w=sizeof(save8type) then begin inc(c);dec(sz,sizeof(save8type))end;
l:=(l-w)-2;
if l>0 then seek(f,filepos(f)+w);
ior:=ioresult;
until not(l>0)or(ior<>0);
seek(f,p);
invalidAnnFile:=(l<>0)and(ior=0);
Bl:=c;
end;

Function TMainApp.InvalidComFile(var F:file;var sz:word):boolean;
var L,L2:Longint;
    s:string;
    a:array[1..length(validcomstr)]of byte;
    numread:word;
Begin
InvalidComFile:=True;
L2:=FileSize(F);
If L2<490+4+6+1 then exit;
L:=FilePos(F);
BlockRead(F,a,length(ValidComStr),numread);
if numread<>length(ValidComStr) then exit;
move(a,s[1],length(validcomstr));
s[0]:=char(length(validcomstr));
if s<>ValidComStr then Exit;
InvalidComFile:=False;
sz:=L2-490;
end;

function  TMainApp.LoadAnn:boolean;
var F:File;
    P:Pointer;
    DPtr:^aob0;
    S:FNameStr;
    THdr:string;
    I,J,K:word;
    L,L1,L2:longint;
    Tmp8:save8type;
    HLen,NumRead,
    Parts,mSize,ptSize:word;
Begin
LoadAnn:=False;
if winList[CurWin]=nil then exit;
with WinList[CurWin]^ do
begin
if Name=Nil then exit;
S:=Name^;
p:=@S;
assign(F,S);
Reset(F,1);
if ioresult<>0 then exit;
if InvalidAnnFile(F,Parts,mSize,HLen)
   then begin System.Close(f);MessageBox(emInvalidFile,@p,mfError or mfokButton);exit end
   else repeat{Until True}
        if memavail-HeapFunds<=msize+parts*sizeof(datstore) then
        if messagebox(emLowMemoryForThisFile,@p,mfYesButton or mfNoButton)<>cmYes
              then continue;
        blockread(F,THdr,Hlen+1,Numread);
        Header:=NewStr(THdr);
        L2:=FilePos(F);K:=CurPart;
        while not Eof(F)do
        begin
        seek(F,l2);
        blockread(F,tmp8,sizeof(tmp8),numread);
        L1:=0;Numread:=0;
        L:=filepos(F);
        while not (eof(F)or(I=sizeof(tmp8)))do
              begin       {Calculate part size}
              blockread(F,I,sizeof(I),numread);
              L2:=FilePos(F);
              if I=sizeof(tmp8)then continue;
              seek(F,L2+I);
              Inc(L1,I);
              end;{While not Eof...}
        if L1<$FFFF then ptSize:=L1 else{ERROR !};
        seek(F,L);I:=0;P:=Nil;
        if memavail-HeapFunds>sizeof(DatStore)+6+1 then
                                   begin
                                   if memavail-HeapFunds<sizeof(DatStore)+ptSize then
                                      ptsize:=((memavail-HeapFunds-sizeof(DatStore))div 6)*6;
                                   GetMem(Dptr,ptSize);
                                   repeat
                                   blockread(F,J,sizeof(J),numread);
                                   blockread(F,DPtr^[i],J,Numread);
                                   inc(i,numread);
                                   until I>=ptSize;
                                   MColl^.AtInsert(K,New(DatPtr,Init(DPtr,Tmp8,ptSize)));
                                   end{then}
                                           else
                                   begin{ERROR}
                                   break
                                   end{Else};
        Inc(K);
        end;{While}
        until true;
end;
Close(F);
LoadAnn:=True;
End;

function TMainApp.LoadCom:boolean;
var F:file;
    P:Pointer;
    DPtr:^aob0;
    S:FNameStr;
    I,J,K:word;
    L,L1,L2:longint;
    Tmp8:save8type;
    HLen,NumRead,
    msize,ptSize:word;
Begin
LoadCom:=False;
if winList[CurWin]=nil then exit;
S:=ComMask;
ChooseStr:=ChooseStr2C;
GetFileName(S,Commask);
if s='' then exit;
with WinList[CurWin]^ do
begin
p:=@S;
assign(F,S);
Reset(F,1);
if ioresult<>0 then begin MessageBox(emFileNotFound,@p,mfError or mfokButton); exit end;
K:=CurPart;
if InvalidComFile(F,mSize)
   then begin System.Close(f);MessageBox(emInvalidFile,@p,mfError or mfokButton);exit end
   else repeat{until True}
        if memavail-HeapFunds<=msize+sizeof(datstore) then
        if messagebox(emLowMemoryForThisFile,@p,mfYesButton or mfNoButton)<>cmYes
              then continue;
        ptSize:=((Msize-4)div 6)*6;
        if memavail-HeapFunds>sizeof(DatStore)+6+1 then
                                   begin
                                   if memavail-HeapFunds<sizeof(DatStore)+ptSize then
                                      ptsize:=((memavail-HeapFunds-sizeof(DatStore))div 6)*6;
                                   GetMem(DPtr,ptSize);
                                   seek(F,490);
                                   blockread(F,Tmp8.save4,4,numread);
                                   tmp8.BenchMark:=TestSpeed;
                                   blockread(F,DPtr^,ptsize);
                                   MColl^.AtInsert(K,New(DatPtr,Init(DPtr,Tmp8,ptSize)));
                                   end{then}
                                           else
                                   begin{ERROR}
                                   break
                                   end{Else};
        until true;
end;
Close(F);
LoadCom:=True;
End;




Function TMainApp.LoadSnd:boolean;
type sndblock=record
              num:byte;
              voice1,
              voice2,
              voice3,
              voice4,
              voice5,
              duration:array[1..24]of byte
              end;
sndtype=array[1..42]of sndblock;
const DurConsts:array[1..10]of byte =
         ($30,$20,$18,$10,$0C,$08,$06,$04,$03,$02);
var  Snd:Sndtype;
     SndLabels:array[1..42]of byte;
     F:file;
     temp,transp:word;
     I,J,K,M:word;
     n:byte;
     L:Longint;
     Err:integer;
     S8:Save8Type;
     S61,S6,S6W:array[1..6]of byte;
     SCache:^aob0;
     P:Pointer;
     s:string;
Begin
LoadSnd:=False;
if winList[CurWin]=nil then exit;
S:=SndMask;
ChooseStr:=ChooseStr2S;
GetFileName(S,SndMask);
if s='' then exit;

assign(f,s);
{$I-}
reset(f,1);
p:=@s;

if ioresult<>0 then begin MessageBox(emFileNotFound,@p,mfError or mfokButton); exit end;

blockread(f,n,1);
case n of
0..253:MessageBox(emInvalidFile,@p,mfError or mfokButton);
255:MessageBox(emThisIsBlock,@p,mfError or mfokButton);
254:begin
    blockread(f,temp,2);
    blockread(f,transp,2);
    k:=(filesize(f)-46)div sizeof(SndBlock);
    fillchar(snd,sizeof(snd),0);
    for i:=1 to k do
      begin
      Blockread(f,n,1);
      if n in[1..42]then
      blockread(f,snd[n].voice1,sizeof(snd[i])-1);
      end;
    blockread(f,n,1);
    if n<>255 then begin
                   MessageBox(emInvalidFile,@p,mfError or mfokButton);
                   n:=0
                   end;
    blockread(f,sndLabels,sizeof(sndLabels));
    n:=254;
    end;
end;

Err:=IOResult;
close(f);

if Err<>0 then begin
               MessageBox(emErrorReadingFile,@p,mfError or mfokButton);
               exit
               end;
if n<>254 then exit;

n:=0;
for I:=1 to 42 do if SndLabels[i]<>0 then inc(n);
NewCache(Pointer(SCache),n*sizeof(snd[1]));
if SCache=Nil then begin
                   MessageBox(emOutOfMemory,Nil,mfError or mfokButton);
                   exit
                   end;
L:=TestSpeed;
with S8 do begin
           Benchmark:=L;
           Save4[1]:=Temp;
           save4[2]:=Transp;
           end;
I:=1;J:=0;
fillchar(s6,sizeof(s6),0);
fillchar(s61,sizeof(s61),0);
fillchar(s6w,sizeof(s6w),0);
for i:=1 to 42 do if SndLabels[I]<>0 then
      begin
      with snd[sndLabels[i]] do
      for k:=1 to 24 do repeat
                        if s6w[6]<>0 then begin
                                          move(s6w,SCache^[J],6);
                                          fillchar(s6w,sizeof(s6w),0);
                                          inc(J,6);
                                          end;
                        if duration[k]<>0then
                           begin
                           s6[1]:=voice1[k];
                           s6[2]:=voice2[k];
                           s6[3]:=voice3[k];
                           s6[4]:=voice4[k];
                           s6[5]:=voice5[k];
                           s6[6]:=duration[k];
                           if(s61[6]=0)then move(s6,s61,5);
                           if s6[6]in[1..10]then
                           if((s6[1]=s61[1])and
                              (s6[2]=s61[2])and
                              (s6[3]=s61[3])and
                              (s6[4]=s61[4])and
                              (s6[5]=s61[5]))
                           then inc(s61[6],DurConsts[s6[6]])
                           else begin move(s61,s6w,6);
                                      move(s6,s61,5);
                                      s61[6]:=DurConsts[s6[6]];
                                end;
                           end;
                        until True;
      end;
move(s61,SCache^[j],6);{᫥ }
fillchar(s6w,sizeof(s6w),0);
inc(J,6);
P:=MemAlloc(J);
if(SCache=Nil)or(P=Nil)then begin
                            MessageBox(emOutOfMemory,Nil,mfError or mfokButton);
                            exit
                            end;
Move(SCache^,P^,J);
DisposeCache(SCache);
if J>0 then
with WinList[CurWin]^ do
MColl^.AtInsert(CurPart,New(DatPtr,Init(P,S8,J)));
LoadSnd:=True;
End;


Function TMainApp.SaveAnn:boolean;
Var F:File;
procedure ErrErase;
Begin
Close(F);
Erase(F);
end;
var NumWritten:word;
    P:pointer;
    Tmp8:save8type;
    I,J,K:word;
    THdr:string;
Begin
SaveAnn:=True;
if winList[CurWin]=nil then exit;
if(winList[CurWin]^.MColl=nil)or(winList[CurWin]^.MColl^.Count=0)then exit;
SaveAnn:=False;
with winlist[CurWin]^ do
begin
if Name=Nil then begin SaveAnn:=SaveAs;exit end;
p:=Name;
K:=0;
assign(F,Name^);
rewrite(F,1);
if ioresult<>0 then begin MessageBox(emErrorCreatingFile,@p,mfError or mfokButton);exit
                    end;
if Header<>Nil then THdr:=Header^ else THdr:='';
blockwrite(f,THdr,length(THdr)+1);
if ioresult<>0 then begin MessageBox(emErrorWritingFile,@p,mfError or mfokButton);
                          ErrErase;exit
                    end;
J:=8;
with MColl^ do
for I:=0 to pred(Count)do
with datptr(At(i))^ do
begin
if I<>0 then blockwrite(f,j,sizeof(j));
blockwrite(f,special,j);
K:=0;
if BytesWrite=0 then begin
                     blockwrite(f,datsize,sizeof(datsize));
                     blockwrite(f,Data^,DatSize);
                     end
                else repeat
                     if Datsize-K<byteswrite then j:=Datsize-k else j:=byteswrite;
                     blockwrite(f,j,sizeof(j));
                     blockwrite(f,Data^[k],j);
                     inc(k,j);
                     until k>=Datsize;
if ioresult<>0 then begin MessageBox(emErrorWritingFile,@p,mfError or mfokButton);
                          ErrErase;exit
                    end;
end{with..for..with}
end;
close(f);
SaveAnn:=True;
End;{Save}

{$V-}
Function TMainApp.SaveAs:boolean;
var S,S1:FNameStr;
    I,J:byte;
    P:pointer;
Begin
SaveAs:=False;
s:=''{AnnMask};
ChooseStr:=ChooseStr4;
GetFileName(s,AnnMask);
if s='' then exit;
s1:=FExpand('');
i:=1;while s[i]=s1[i] do inc(i);
s1:=copy(s,i,length(s)-i+1);p:=@s1;
if FileExists(s) then if messagebox(emFileAlreadyExists,@p,mfYesNoCancel or mfWarning)<>cmYes
 then s:='';
If s<>'' then begin
              J:=HelpCtx;
              winlist[CurWin]^.Name:=NewStr(s);
              ReadWriteName:=s;
              HelpCtx:=hcSaving;
              StatusLine^.Update;
              SaveAs:=SaveAnn;
              HelpCtx:=J
              end;
End;

Procedure TMainApp.SaveAll;
var I,J,K:word;
Begin
J:=CurWin;
K:=HelpCtx;
for I:=1 to 9 do if WinList[i]<>Nil then Begin
                                         CurWin:=I;
                                         if winlist[i]^.name=nil
                                           then ReadWriteName:=''
                                           else ReadWriteName:=winlist[i]^.name^;
                                         HelpCtx:=hcSaving;
                                         StatusLine^.Update;
                                         WinList[i]^.Modified:=not SaveAnn;
                                         HelpCtx:=K;
                                         StatusLine^.Update;
                                         end;
HelpCtx:=K;
CurWin:=J
End;


Procedure TMainApp.WriteCom;
type codeBEG16 = array[1..16] of byte;
     codeEND17 = array[1..17]of byte;
     code93    = record
                 svsi,
                 svbp:word;
                 code1:byte;
                 svptr:word;{BX}
                 code2:array[1..39]of byte;
                 blsize:word;{CX}
                 code3:array[1..45]of byte;
                 end;
const begcode:codeBEG16=($BA,$10,$01,
                         $B4,$40,
                         $BB,$01,$00,
                         $B9,00,00,
                         $CD,$21,
                         $E9,00,00);
      endcode:codeEND17=($B8,$00,$01,
                         $50,
                         $B9,00,00,
                         $BF,$00,$01,
                         $BE,00,00,
                         $FC,
                         $F3,$A4,
                         $C3);
      bigcode1:code93=
        (   svsi:0;
            svbp:0;
            code1:$BB;
            svptr:0;{BX}
            code2:($55,$8B,$6F,$02,$B4,$01,$CD,$16,$74,$0D,$33,$C0,$CD,$16,
                   $3E,$8A,$46,$00,$5D,$B4,$4C,$CD,$21,$1E,$07,$BF,$EA,$02,
                   $3E,$8B,$46,$02,$AB,$3E,$8B,$46,$04,$AB,$B9);
            blsize:0;{CX}
            code3:($3E,$3B,$4E,$00,$72,$14,$3E,$8B,$4E,$00,$E3,$D9,$3E,$C7,
            $46,$00,$00,$00,$83,$C5,$06,$89,$6F,$02,$EB,$04,$3E,$29,$4E,$00,
            $8B,$37,$F3,$A4,$C6,$05,$FF,$89,$37,$5D,$B8,$00,$01,$50,$C3)
        );
var F:file;
    TmpBuf:^Aob0;
    L,L1:longint;
    i,j,k:word;
    s,s1:string;
    P:Pointer;
    nw:word;
    s8:save8type;
    s6:record sz:word;save4:array[1..2]of word end;
    err:integer;
    n:byte;
    wrhdr,kbstop:word;
procedure ErrErase;Begin Close(F);Erase(F) end;
Begin
{$I-}
if winList[CurWin]=nil then exit;
if(winList[CurWin]^.MColl=nil)or(winList[CurWin]^.MColl^.Count=0)then exit;
L:=0;
with WinList[CurWin]^do
with MColl^ do
for i:=0 to Count-1 do
   with Datptr(At(i))^ do inc(L,DatSize);{L - General size of data}
L1:=L+sizeof(MusBeg)+5;
wrhdr:=writeheader;kbstop:=kbStopCom;
if kbStop=2 then
case MessageBox(kbStopComAskStr,nil,mfConfirmation or mfYesNoCancel) of
cmYes:kbStop:=0;
cmNo :kbStop:=1;
cmCancel:exit
end;
if WinList[CurWin]^.Header=Nil then WrHdr:=1;
if WrHdr=2 then
case MessageBox(WriteHeaderAskStr,nil,mfConfirmation or mfYesNoCancel) of
cmYes:WrHdr:=0;
cmNo :WrHdr:=1;
cmCancel:exit
end;
with WinList[CurWin]^do
if kbStop=0 then begin
                    inc(L1,sizeof(BigCode1));
                    inc(L1,MColl^.Count*6+2);
                    end;
if WrHdr=1 then
if L1>=65536 then begin
                  MessageBox(emComFileTooBig,Nil,mfError or mfOKButton);
                  exit
                  end
             else
                 else
with WinList[CurWin]^do
if((Header<>NIL)and(L1+length(Header^)>=65536))or(L1>=65536)then
                  begin
                  MessageBox(emComFileTooBig,Nil,mfError or mfOKButton);
                  exit
                  end;
S:='';
ChooseStr:=ChooseStr7;
GetFileName(S,ComMask);
if s='' then exit;
s1:=FExpand('');
i:=1;while s[i]=s1[i] do inc(i);
s1:=copy(s,i,length(s)-i+1);p:=@s1;
if FileExists(s) then if messagebox(emFileAlreadyExists,@p,mfYesNoCancel or mfWarning)<>cmYes
 then s:='';
if s='' then exit;
assign(f,s);
rewrite(f,1);
if ioresult<>0 then begin MessageBox(emErrorCreatingFile,@p,mfError or mfokButton);exit
                    end;
with WinList[CurWin]^do
if(WrHdr=0)and(Header<>Nil)then
              begin
              S:=header^+#13#10;
              i:=length(s);
              move(i,begcode[10],2);
              move(i,begcode[15],2);
              blockwrite(f,begcode,sizeof(begcode));
              blockwrite(f,s[1],i);
              i:=l1;
              move(i,endcode[6],2);
              i:=length(s)+$100+sizeof(begcode)+sizeof(endcode);
              move(i,endcode[12],2);
              blockwrite(f,endcode,sizeof(endcode));
              end;
if ioresult<>0 then begin MessageBox(emErrorWritingFile,@p,mfError or mfokButton);
                          ErrErase;exit
                    end;
TmpBuf:=MemAlloc(sizeof(MusBeg));
if TmpBuf=Nil then begin MessageBox(emOutOfMemory,Nil,mfError or mfokButton);
                         ErrErase;exit
                   end;
Move(MusBeg,TmpBuf^,sizeof(MusBeg));
K:=BytesWriteCom;
with WinList[CurWin]^do
with MColl^ do
begin
for i:=0 to Count-1 do
   with Datptr(At(i))^ do if DatSize<k then k:=DatSize;
I:=241+k;
if kbStop=0 then begin Tmpbuf^[255]:=$E9;Tmpbuf^[256]:=lo(i);Tmpbuf^[257]:=hi(i)end;
blockwrite(f,Tmpbuf^,sizeof(musbeg),nw);
freemem(Tmpbuf,sizeof(musbeg));
L1:=TestSpeed;
S8:=DatPtr(MColl^.At(0))^.Special;
s8.save4[1]:=round(s8.save4[1]/(S8.Benchmark/L1));
s8.save4[2]:=round(s8.save4[2]*(S8.Benchmark/L1))and 254;
blockwrite(f,s8.save4,4,nw);
Case kbStop of
1:begin
  for i:=0 to MColl^.Count-1 do
    with DatPtr(MColl^.At(i))^ do
    begin
    k:=Datsize;
    if Data^[k-1]=$FF then dec(k);
    blockwrite(f,Data^,k);
    Err:=IOResult;
    if Err<>0 then break;
    end;
  i:=$FF;
  blockwrite(f,i,1);
  Err:=IOResult;
  end;
0:begin
  {k = least part size or byteswritecom}
  j:=DatPtr(MColl^.At(0))^.DatSize-k;
  blockwrite(f,DatPtr(MColl^.At(0))^.Data^,k);
  n:=$FF;blockwrite(f,n,1);{1-st block is written}
  {Now set up the code}
  with bigcode1 do begin
                   svsi  :=$100+494+sizeof(code93)+k+1;
                   svbp  :=$100+494+sizeof(code93)+l+1;
                   svptr :=$100+494+k+1;
                   blsize:=k;
                   end;
  blockwrite(f,bigcode1,sizeof(bigcode1));
  err:=ioresult;
  if err=0 then
    blockwrite(f,DatPtr(MColl^.At(0))^.Data^[k],j);
  err:=ioresult;
  if err=0 then
  for i:=1 to MColl^.Count-1 do
    with DatPtr(MColl^.At(i))^ do
      begin
      k:=datsize;
      if Data^[k-1]=$FF then Dec(k);
      BlockWrite(f,Data^,k);
      err:=Ioresult;
      if Err<>0 then break
      end;
  if err=0 then
  for i:=0 to MColl^.Count-1 do
    with DatPtr(MColl^.At(i))^ do
      begin
      k:=DatSize;
      if i=0 then k:=j;{J= ..[0]^datsize - byteswritecom(or least part size)}
      s6.sz:=k;
      s8:=special;
      s8.save4[1]:=round(s8.save4[1]/(S8.Benchmark/L1));
      s8.save4[2]:=round(s8.save4[2]*(S8.Benchmark/L1))and 254;
      move(s8.save4,s6.save4,4);
      blockwrite(f,s6,sizeof(s6));
      err:=ioresult;
      if err<>0 then break;
      end;
  k:=0;
  if err=0 then
           begin
           blockwrite(f,k,2);err:=ioresult
           end
  end
end;{of Case}
end;{with WinList ...}
if err<>0 then begin MessageBox(emErrorWritingFile,@p,mfError or mfokButton);
                     ErrErase;exit
               end;
close(f)
End;

Procedure TMainApp.PlayAll;
var I,J,K,N,W:word;
    om:byte;
    Tmp8:Save8type;
    E:TEvent;
    p:pwordarray;
    l:longint;
Begin
if winList[CurWin]=nil then exit;
with winlist[CurWin]^ do
begin
om:=mem[seg0040:$17] and 112;
Playing:=True;
I:=BytesPlay;
w:=testspeed;
getmem(p,sizeof(wplaydata));
move(wplaydata,p^,sizeof(wplaydata));
with MColl^ do
for K:=0 to pred(Count)do
begin
with Datptr(At(k))^do
begin
Tmp8:=Special;
 if AutoSetupTemp then
   with Tmp8 do
   begin
     save4[1]:=round(save4[1]/(benchmark/w));
     {save4[2]:=round(save4[2]/(w/benchmark))and$FFFE;}
     save4[2]:=save4[2]and$FFFE;
     move(p^,wplaydata,sizeof(wplaydata));
     for n:=1 to High(wplaydata) do
      begin
      l:=round(longint((wplaydata[n])*benchmark)/w);
      if l=0 then l:=1;
      if LongRec(l).hi<>0 then LongRec(l).Lo:=$FFFF;
      wplaydata[n]:=LongRec(l).Lo;
      end;
     benchmark:=w;
   end;
N:=0;
repeat
if I>DatSize-N then J:=DatSize-N else J:=I;
MyPlay(Data^[N],Tmp8.save4,J);
inc(N,J);
GetEvent(E);
until(N>=DatSize)or(E.What and(evMouseDown or evKeyDown or evCommand)<>0);
if(E.What and(evMouseDown or evKeyDown or evCommand)<>0)then break;
end{with}
end;{for}
Playing:=False;
mem[seg0040:$17]:=(mem[seg0040:$17] and $8F) or om;
move(p^,wplaydata,sizeof(wplaydata));
freemem(p,sizeof(wplaydata));
end
End;


Procedure TMainApp.PlayOnDisplay;
var PM:Procedure (var mus;var tt;cnt:word;ChAttr:word;IsCh:boolean);
    I,J,K,M,N:word;
    D:DatPtr;
    W:word;
    Tmp8:Save8type;
Begin
if winList[CurWin]=nil then exit;
ClearScreen;
@PM:=ScreenBuffer;
{@PM:=ptr($B900,0);}
Move(@MyPlayForScreen^,@PM^,PlayLimit+300+490);
Blinking(BlinkingChars);
PlayingOnScreen:=True;
with winlist[CurWin]^ do
begin
I:=BytesPlay;
w:=testspeed;
with MColl^ do
for K:=0 to pred(Count)do
begin
N:=0;
with Datptr(At(k))^do
begin
Tmp8:=Special;
 if AutoSetupTemp then
   with Tmp8 do
   begin
     save4[1]:=round((save4[1]/(benchmark/w))/PlayScreenTempDivisor);
     save4[2]:=round((save4[2]/(w/benchmark))*PlayScreenTranspMultiplicator)and$FFFE;
     benchmark:=w;
   end;
repeat
if I>DatSize-N then J:=DatSize-N else J:=I;
if BlinkingChars then
if M=PlayOnScreenCharAttr1 then M:=PlayOnScreenCharAttr2
                           else M:=PlayOnScreenCharAttr1;
PM(Data^[N],Tmp8.save4,J,M,BlinkingChars);
inc(N,J);
until(N>=DatSize)or(memw[seg0040:$1A]<>memw[seg0040:$1C]);
if (memw[seg0040:$1A]<>memw[seg0040:$1C])then break;
end{with}
end{for}
end;{with}
memw[seg0040:$1A]:=memw[seg0040:$1C];
Blinking(EnableBlinking);
PlayingOnScreen:=False;
Redraw
End;

Procedure TMainApp.OpenNew;
Var R,R1:TRect;
    I,J,HC:word;
    S,s1:FNameStr;
    Dir:DirStr;
    Nam:NameStr;
    Ext:ExtStr;
    TheWindow:PMyWin;
    NewCreated:Boolean;
Begin
for I:=1 to 9 do if(winlist[i]=Nil)
 or((WinList[i]^.Name=Nil)and(WinList[i]^.MColl^.Count=0)and(OpenIntoEmpty=1))then break;
if(winlist[I]<>Nil)and
 (not((WinList[i]^.Name=Nil)and(WinList[i]^.MColl^.Count=0)and(OpenIntoEmpty=1)))then exit;
if Nm=''then
begin
S:=AnnMask;
ChooseStr:=ChooseStr2A;
GetFileName(S,AnnMask);
if s='' then exit;
end
else
begin
if(pos('*',Nm)<>0)or(pos('?',Nm)<>0)then
                                    begin
                                    S:=Nm;
                                    GetFileName(S,AnnMask);
                                    if s='' then exit;
                                    end
                                    else s:=Nm;
end;
J:=CurWin;
FSplit(S,Dir,Nam,Ext);
GetExtent(R);
Dec(R.B.Y,2);
minwinsize.y:=5;
if(winlist[I]<>Nil)
 and((WinList[i]^.Name=Nil)and(WinList[i]^.MColl^.Count=0)and(OpenIntoEmpty=1))
        then begin TheWindow:=WinList[I];WinList[i]^.Name:=NewStr(S);J:=0;NewCreated:=False end
        else begin New(TheWindow,Init(R,I,S,@Self));WinList[I]:=TheWindow;NewCreated:=True end;
HC:=HelpCtx;
HelpCtx:=hcReading;
ReadWriteName:=winlist[i]^.name^;
StatusLine^.Update;
{$B-}
if not LoadAnn
then begin dispose(TheWindow,Done);WinList[I]:=Nil;CurWin:=j;
           CreateNew;WinList[I]^.Name:=NewStr(S);WinList[I]^.DrawView
     end
else
begin
TheWindow^.Interior^.setlimit(IscrollstringX,TheWindow^.MColl^.count);
If NewCreated then
if(TheWindow^.MColl^.count+3<TheWindow^.size.y)
      then
        begin
        if(TheWindow^.MColl^.count+4>=MinWinsize.y)
        then R.B.Y:=R.A.Y+4+TheWindow^.MColl^.count
        else R.B.Y:=R.A.Y+MinWinsize.y;
        TheWindow^.ChangeBounds(R)
        end else
              else
              TheWindow^.DrawView;
DeskTop^.GetExtent(R);
if(J>0)and(WinList[J]^.Origin.Y+MinWinSize{TheWindow^.Size}.Y<=R.B.Y-R.A.Y)then
  begin
       TheWindow^.Origin.Y:=succ(WinList[J]^.Origin.Y);
       if TheWindow^.Origin.Y+TheWindow^.Size.Y<R.B.Y
       then R.B.Y:=TheWindow^.Origin.Y+TheWindow^.Size.Y;
       R.Assign(TheWindow^.Origin.X,TheWindow^.Origin.Y,
         TheWindow^.Origin.X+TheWindow^.Size.X,R.B.Y);
       TheWindow^.ChangeBounds(R)
  end;
InsertWindow(TheWindow)
end;
HelpCtx:=HC
End;


Procedure TMainApp.CreateNew;
Var R,R1:TRect;
    I,J,K:word;
    S,s1:FNameStr;
    TheWindow:PMyWin;
Begin
for I:=1 to 9 do if winlist[i]=Nil then break;
if winlist[I]<>Nil then exit;
k:=0;
for j:=1 to 9 do if(winlist[J]<>Nil)and(winlist[j]^.Name=Nil)then inc(k);
str(k,s1);while length(s1)<2 do s1:='0'+s1;
S1:=nonamestr+s1+AnnExt;
GetExtent(R);
J:=CurWin;
CurWin:=I;
Dec(R.B.Y,2);
minwinsize.y:=5;
New(TheWindow,Init(R,I,'',@Self));
WinList[CurWin]:=TheWindow;
TheWindow^.Interior^.setlimit(IscrollstringX,TheWindow^.MColl^.count);
TheWindow^.Title:=NewStr(s1);
if(TheWindow^.MColl^.count+3<TheWindow^.size.x)
      then
        begin
        if(TheWindow^.MColl^.count+4>=MinWinsize.y)
        then R.B.Y:=R.A.Y+4+TheWindow^.MColl^.count
        else R.B.Y:=R.A.Y+MinWinsize.y;
        TheWindow^.ChangeBounds(R);
        end;
DeskTop^.GetExtent(R);
if(J>0)and(WinList[J]^.Origin.Y+TheWindow^.Size.Y+2<R.B.Y-R.A.Y)then
  begin
       TheWindow^.Origin.Y:=succ(WinList[J]^.Origin.Y);
       if TheWindow^.Origin.Y+TheWindow^.Size.Y<R.B.Y
       then R.B.Y:=TheWindow^.Origin.Y+TheWindow^.Size.Y;
       R.Assign(TheWindow^.Origin.X,TheWindow^.Origin.Y,
         TheWindow^.Origin.X+TheWindow^.Size.X,R.B.Y);
       TheWindow^.ChangeBounds(R)
  end;
InsertWindow(TheWindow);
End;


{}

Constructor  TMyWin.Init;
var HS,VS:PScrollBar;
Begin
Inherited Init(Bounds,'',Id);
MColl:=Nil;
Num:=Id;
Header:=Nil;
Name:=NewStr(FlName);
CurrentPart(0);
Playing:=False;
Modified:=False;
MainOwner:=PM;
GetClipRect(Bounds);
New(MColl,Init(1,1));
if MColl=Nil then Fail;
Options:=Options or ofTileable;
{GrowMode:=gfGrowLoX or gfGrowLoY or gfGrowRel;}
MakeCurrent;
SetMyWinCommands;
Bounds.Grow(-1,-1);
inc(Bounds.A.Y);
VS:=StandardScrollBar(sbVertical);
HS:=StandardScrollBar(sbHorizontal+sbHandleKeyBoard);
Interior:=New(PInterior,Init(Bounds,HS,VS,@Self));
Insert(Interior);
End;


Destructor TMyWin.Done;
Begin
MainOwner^.WinList[Num]:=Nil;
Dispose(MColl,Done);
Num:=0;
if Header<>Nil then DisposeStr(Header);
if Name<>Nil then DisposeStr(Name);
Inherited Done;
DisableCommands(DisIniComSet);
EnableCommands(EnIniComSet);
end;

Procedure TMyWin.HandleEvent(var E:TEvent);
var b,msghandled:boolean;
    HC,w:word;
    MP:TPoint;
Begin
Inherited HandleEvent(E);
msghandled:=True;
w:=curpart;
b:=(GetShiftState and(kbLeftShift or kbRightShift))<>0;

if (E.What and evKeyDown)<>0 then
case E.KeyCode of
kbUp    : if CurPart>0 then Currentpart(pred(curpart));
kbDown  : if curpart<MColl^.count then Currentpart(succ(curpart));
kbPgUp  :if CurPart>Interior^.Size.Y then CurrentPart(CurPart-Interior^.size.Y)
                                     else CurrentPart(0);
kbPgDn  :if CurPart+Interior^.Size.Y<MColl^.Count then CurrentPart(Curpart+Interior^.size.Y)
                                                  else CurrentPart(MColl^.Count);
kbCtrlPgUp:CurrentPart(0);
kbCtrlPgDn:CurrentPart(MColl^.Count);
kbCtrlHome:CurrentPart(Interior^.Delta.Y);
kbCtrlEnd :if Interior^.Delta.Y+Interior^.Size.Y-1<=MColl^.Count then
              CurrentPart(Interior^.Delta.Y+Interior^.Size.Y-1)  else
              CurrentPart(MColl^.Count);
3389,{ + and = }
kbGrayPlus :if(CurPart<MColl^.Count)and(CurPos<Datptr(MColl^.At(CurPart))^.DatSize)then inc(CurPos,6);
3117,{ - and _ }
kbGrayMinus:if CurPos>0 then dec(CurPos,6)else CurPos:=Datptr(MColl^.At(CurPart))^.DatSize
else msghandled:=False
end;

if b then
if(curpart>w)and((not((w>0)and(MColl^.AtMarked(pred(w)))))or(MColl^.AtMarked(CurPart)))then unmarkall else
if(curpart<w)and((not(MColl^.AtMarked(w)))or(MColl^.AtMarked(CurPart)))then unmarkall;
if(w<Curpart)and(curpart>0)and b then markpart(w,pred(Curpart),true,XorSet);
if(w>Curpart)and b then markpart(pred(w),Curpart,true,XorSet);


if E.What=evCommand then
case E.Command of
cmPlay:Begin HC:=HelpCtx;
             if Title<>Nil then PlayName:=StripTitle(Title^)
             else PlayName:='';
             HelpCtx:=hcPlaying;
             StatusLine^.Update;
             PlayFrom;
             HelpCtx:=HC
             end;
cmSave:If Modified then
             begin
             HC:=HelpCtx;
             HelpCtx:=hcSaving;
             ReadWriteName:=Name^;
             StatusLine^.Update;
             Modified:=not MainOwner^.SaveAnn;
             HelpCtx:=HC;
             end;
cmSaveAs :begin Modified:=not MainOwner^.SaveAs end;
cmWriteCom:MainOwner^.WriteCom;
cmReadCom:begin b:=MainOwner^.LoadCom;Modified:=b or Modified;if b then inc(curpart) end;
cmReadSnd:begin b:=MainOwner^.LoadSnd;Modified:=b or Modified;if b then inc(curpart) end;
cmMark:if curpart<MColl^.count then begin markpart(Curpart,Curpart,true,XorSet);
           if MarkDown then Currentpart(succ(curpart))end;
cmCut:EditCut;
cmCopy:EditCopy;
cmClear:EditClear;
cmPaste:EditPaste;
cmEditHeader:EditHeader;
cmEditTemp:EditTemp;
cmEditTransp:EditTransp;
else MsgHandled:=False
end
else MsgHandled:=False;
if msghandled then Draw;

msghandled:=True;
if E.What=evBroadCast then
with MainOwner^ do
case E.Command of
cmReceivedFocus:MakeCurrent;
cmReleasedFocus:ReleaseCurrent;
cmCommandsetchanged:begin Interior^.DrawView end;
end
else MsgHandled:=False;

if getstate(sfActive) then SetMyWinCommands;

if msghandled then Show;

If(E.What=EvMouseDown)and(E.Double)and(MouseInView(E.Where))then
      begin
      MakeLocal(E.Where,MP);
      if MP.Y=1 then EditHeader
      end
End;



Function  TMyWin.Valid(Command:word):boolean;
var HC:word;
Begin
If Command=cmValid then begin Valid:=True;exit end;
if(Command=cmClose)and modified
  then
     case MessageBox(emHasChanged,@Title,mfInformation or mfYesNoCancel) of
     cmYes:begin
           HC:=HelpCtx;
           HelpCtx:=hcSaving;
           if Name=Nil then ReadWriteName:=''
                       else ReadWriteName:=Name^;
           StatusLine^.Update;
           Modified:=not MainOwner^.SaveAnn;
           Valid:=not Modified;
           HelpCtx:=HC;
           end;
     cmNo :Valid:=True;
     cmCancel:Valid:=False
     end
  else Valid:=True
End;

Procedure TMyWin.Draw;
var B:TDrawBuffer;
    Color,i,k:byte;
    s:string;
Begin
{if buffer=nil then NewCache(Pointer(Buffer),(Size.X*Size.Y)shl 1);}
if not playing then
begin
if Name=Nil then
       begin
       k:=0;
       with MainOwner^ do
       for i:=1 to 9 do if(winlist[i]<>Nil)and(winlist[i]^.Name=Nil)then inc(k);
       str(k,s);
       while length(s)<2 do s:='0'+s;
       S:=nonamestr+s
       end
            else
       begin
       s:=Fexpand('');i:=1;
       while(s[i]=Name^[i])and(I<=Length(s))and(I<=Length(Name^))do inc(i);
       DisposeStr(Title);
       if i=1 then Title:=NewStr(Name^)
              else
       if i<length(s)then
       Title:=NewStr(copy(Name^,3,length(Name^)))
              else
       Title:=NewStr(copy(Name^,i,length(Name^)));
       Frame^.Draw;
       end;
if Header=Nil then s:=''
              else s:=Header^;
while length(s)<size.x-2 do s:=' '+s+' ';
movestr(b,s,GetColor(10));
Inherited Draw;
writeline(1,1,size.x-2,1,B);
end
end;

Function TMyWin.GetPalette:PPalette;
Begin
GetPalette:=@CMyWindowPalette
End;

Procedure TMyWin.CurrentPart(N:word);
Begin
CurPart:=N;
CurPos:=0
End;

Procedure TMyWin.MarkPart(p1,p2:word;stat:boolean;bitblt:byte);
var b:Boolean;
Begin
if p1>p2 then asm mov ax,p1;push ax;mov ax,p2;mov p1,ax;pop ax;mov p2,ax end;
for p1:=p1 to p2 do
if p1<MColl^.Count then with Datptr(MColl^.At(p1))^ do
begin
b:=marked;
case bitblt of
ANDSet:marked:=marked and stat;
 ORSet:marked:=marked  or stat;
XORSet:Marked:=marked xor stat
end;
b:=marked;
end

End;


Procedure TMyWin.UnMarkAll;
var i:word;
Begin
for i:=0 to pred(MColl^.Count)do MColl^.AtUnMark(i)
End;



Procedure TMyWin.EditTransp;
Var  PD:PTranspDialog;
     S:string;
     tr:word;
     TDD:TranspDlgData;
     Code:Integer;
     Ratio:real;
Begin
str(Datptr(MColl^.At(CurPart))^.Special.save4[2] div 2,s);
With TDD do begin str:=s;tr:=Datptr(MColl^.At(CurPart))^.Special.save4[2] div 2 end;
New(PD,Init(tr));
Code:=Application^.ExecuteDialog(PD,@TDD);
case Code of
cmCancel   :Exit;
cmOk       :begin val(TDD.str,tr,code);
            if code=0 then Datptr(MColl^.At(CurPart))^.Special.save4[2]:=tr*2
            end;
cmTDlgChangeAll:
            begin val(TDD.str,tr,code);
            if code=0 then begin
                           Ratio:=Datptr(MColl^.At(CurPart))^.Special.save4[2]/(tr*2);
                           for Code:=0 to pred(MColl^.Count)do
                           with MColl^ do if(TRChangeAll=1)or(AtMarked(Code))or(Code=CurPart)
                           then Datptr(At(Code))^.Special.save4[2]:=
                           Round(Datptr(At(Code))^.Special.save4[2]/Ratio)and $FFFE;
                           end
            end
end;
Modified:=True
End;


Procedure TMyWin.EditTemp;
var  PD:PTempDialog;
     S:string;
     tm:word;
     L:Longint;
     TDD:TTempDlgData;
     Code:Integer;
     Rat,Ratio:real;
Begin
tm:=Datptr(MColl^.At(CurPart))^.Special.save4[1];
str(tm,s);
With TDD do str:=s;
L:=TestSpeed;
Rat:=L/Datptr(MColl^.At(CurPart))^.Special.BenchMark;
str(Rat:1:3,s);
With TDD do str1:=copy(s,1,6);

New(PD,Init(tm));
Code:=Application^.ExecuteDialog(PD,@TDD);
case Code of
cmCancel   :Exit;
cmOk:begin val(TDD.str,tm,code);
     if code=0 then Datptr(MColl^.At(CurPart))^.Special.save4[1]:=tm;
     val(TDD.str1,rat,code);
     if code=0 then Datptr(MColl^.At(CurPart))^.Special.benchmark:=Round(L/Rat)
     end;
cmTDlgChangeAll:
     begin
     val(TDD.str,tm,Code);
     if code=0 then begin
                    Ratio:=Datptr(MColl^.At(CurPart))^.Special.save4[1]/tm;
                    for code:=0 to pred(MColl^.Count)do
                    with MColl^ do if(TMChangeAll=1)or(AtMarked(Code))or(code=curpart)
                    then Datptr(At(Code))^.Special.Save4[1]:=
                     Round(Datptr(At(Code))^.Special.Save4[1]/Ratio)
                    end;
     val(TDD.str1,Rat,Code);
     if code=0 then begin
                    Ratio:=Datptr(MColl^.At(Code))^.Special.Benchmark/(L/Rat);
                    for code:=0 to pred(MColl^.Count)do
                    with MColl^ do if(TMChangeAll=1)or(AtMarked(Code))or(code=curpart)
                    then Datptr(At(Code))^.Special.Benchmark:=
                    Round(Datptr(At(Code))^.Special.Benchmark/Ratio)
                    end
     end
end;
Modified:=True
End;


Procedure TMyWin.EditHeader;
var S:String;
    PD:PDialog;
    R:TRect;
    PB:PButton;
    PI:PInputLine;
    PH:PHistory;
Begin
if Header=Nil then S:='' else s:=Header^;
R.Assign(12,8,67,16);
PD:=New(PDialog,Init(R,EditHeaderTitleStr));
if PD=Nil then exit;
with PD^ do
     begin
     R.Assign(14,5,26,7);
     PB:=New(PButton,Init(R,'O~K~',cmOk,bfDefault));
     PB^.HelpCtx:=hcDlg+hcEHOKButton;
     Insert(PB);
     R.Assign(30,5,42,7);
     PB:=New(PButton,Init(R,'~C~ancel',cmCancel,bfNormal));
     PB^.HelpCtx:=hcDlg+hcCancelButton;
     Insert(PB);

     R.Assign(5,2,49,3);
     PI:=New(PInputLine,Init(R,250));
     PI^.HelpCtx:=hcDlg+hcEHInputLine;
     Insert(PI);
     R.Assign(49,2,52,3);
     PH:=New(PHistory,Init(R,PI,HeaderHist));
     Insert(PH);
     R.Assign(2,1,2+Length(EditHeaderLabelStr),2);
     Insert(New(PLabel,Init(R,EditHeaderLabelStr,PI)));
     end;
if Application^.ExecuteDialog(PD,@S)=cmOk
  then begin
       disposestr(Header);
       Header:=NewStr(S);
       Modified:=True
       end
end;


Procedure TMyWin.EditCopy;
var I:Integer;
    J,K:word;
    L:longint;
Begin
if WordEditCache<>Nil then DisposeCache(WordEditCache);
L:=0;j:=0;
With MColl^ do
for I:=0 to pred(Count) do if AtMarked(I)then
begin
 inc(L,DatPtr(At(I))^.DatSize+sizeof((DatPtr(At(I))^.DatSize))+sizeof((DatPtr(At(I))^.Special)));
inc(j)
end;
K:=(L+2) and (-1);
NewCache(PointerEditCache,K);
if WordEditCache=Nil then Exit;
WordEditCache^[0]:=j;K:=2;
With MColl^ do
for i:=0 to Pred(Count)do
 if AtMarked(I) then
         begin
         J:=sizeof((DatPtr(At(I))^.DatSize));
         move(Datptr(At(i))^.DatSize,ByteEditCache^[k],J);
         inc(k,j);
         J:=sizeof((DatPtr(At(I))^.Special));
         move(Datptr(At(i))^.Special,ByteEditCache^[k],J);
         inc(k,j);
         J:=DatPtr(At(I))^.DatSize;
         move(Datptr(At(i))^.Data^,ByteEditCache^[k],J);
         inc(k,j)
         end
End;


Procedure TMyWin.EditCut;
var I:Integer;
    J,K:word;
    L:longint;
Begin
if WordEditCache<>Nil then DisposeCache(WordEditCache);
L:=0;j:=0;
With MColl^ do
for I:=0 to pred(Count) do if AtMarked(I)then
begin
 inc(L,DatPtr(At(I))^.DatSize+sizeof((DatPtr(At(I))^.DatSize))+sizeof((DatPtr(At(I))^.Special)));
inc(j)
end;
K:=(L+2) and (-1);
NewCache(PointerEditCache,K);
if WordEditCache=Nil then Exit;
WordEditCache^[0]:=j;K:=2;
With MColl^ do
for i:=0 to Pred(Count)do
 if AtMarked(I) then
         begin
         J:=sizeof((DatPtr(At(I))^.DatSize));
         move(Datptr(At(i))^.DatSize,ByteEditCache^[k],J);
         inc(k,j);
         J:=sizeof((DatPtr(At(I))^.Special));
         move(Datptr(At(i))^.Special,ByteEditCache^[k],J);
         inc(k,j);
         J:=DatPtr(At(I))^.DatSize;
         move(Datptr(At(i))^.Data^,ByteEditCache^[k],J);
         inc(k,j);
         end;
With MColl^ do
begin
for i:=0 to Pred(Count)do while AtMarked(I) do AtFree(I);
Pack;
if CurPart>Count then CurPart:=Count
end;
Modified:=True
End;

Procedure TMyWin.EditClear;
var I:Integer;
Begin
With MColl^ do
begin
for i:=0 to Pred(Count)do while AtMarked(I) do AtFree(I);
Pack;
if CurPart>Count then CurPart:=Count
end;
Modified:=True
End;


Procedure TMyWin.EditPaste;
var I:Integer;
    J,K,M,N:word;
    P:pointer;
    Tmp8:Save8type;
Begin
if WordEditCache=Nil then Exit;
M:=CurPart;
k:=2;
with MColl^ do
for I:=1 to WordEditCache^[0]do
    begin
    J:=sizeof((DatPtr(P)^.DatSize));
    move(ByteEditCache^[k],N,j);
    inc(k,j);
    if MaxAvail<HeapFunds then break;
    P:=MemAlloc(N);
    J:=sizeof((DatPtr(P)^.Special));
    move(ByteEditCache^[k],Tmp8,j);
    inc(k,j);
    J:=N;
    move(ByteEditCache^[k],P^,J);
    inc(k,j);
    AtInsert(M,New(DatPtr,Init(P,Tmp8,N)));
    if CollResult<>0 then break;
    AtMark(M);
    Inc(M);
    end;
Modified:=True
End;

Procedure TMyWin.PlayFrom;
var I,J,K,N,W:word;
    om:byte;
    D:Pointer;
    E:TEvent;
    p:pwordarray;
    l:longint;
Begin
if MColl=Nil then Exit;
I:=BytesPlay;
w:=testspeed;
getmem(p,sizeof(wplaydata));
move(wplaydata,p^,sizeof(wplaydata));
Cur8.BenchMark:=W;
N:=CurPos;
om:=mem[seg0040:$17] and 112;
Playing:=True;
Repeat Until MouseButtons=0;
with MColl^ do
for K:=Curpart to pred(Count)do
begin
Curpart:=K;
with Datptr(At(k))^do
begin
Cur8:=Special;
if AutoSetupTemp then
   with Cur8 do
   begin
     save4[1]:=round(save4[1]/(benchmark/w));
     {save4[2]:=round(save4[2]/(w/benchmark))and$FFFE;}
     move(p^,wplaydata,sizeof(wplaydata));
     save4[2]:=save4[2]and$FFFE;
     for j:=1 to High(wplaydata) do
      begin
      l:=round(longint((wplaydata[j])*benchmark)/w);
      if l=0 then l:=1;
      if LongRec(l).hi<>0 then LongRec(l).Lo:=$FFFF;
      wplaydata[j]:=LongRec(l).Lo;
      end;
     benchmark:=w;
   end;
repeat
if I>DatSize-N then J:=DatSize-N else J:=I;
inc(CurPos,J);
Interior^.DrawView;
MyPlay(Data^[N],Cur8.save4,J);
inc(N,I);
GetEvent(E);
until(N>=DatSize)or(E.What and(evMouseDown or evKeyDown or evCommand)<>0);
if(E.What and(evMouseDown or evKeyDown or evCommand)<>0)then break;
N:=0;
CurPos:=0
end;{with}
CurPart:=k
end;{for}
Playing:=False;
mem[seg0040:$17]:=(mem[seg0040:$17] and $8F) or om;
move(p^,wplaydata,sizeof(wplaydata));
freemem(p,sizeof(wplaydata));
if(curpart>=pred(MColl^.Count))and(Curpos=0) then Curpart:=0;
Interior^.DrawView;
End;

Procedure TMyWin.MakeCurrent;
Begin
if Num=0 then exit;
MainOwner^.CurWin:=Num;
{MainOwner^.WinList[Num]:=@Self}
end;

Procedure TMyWin.ReleaseCurrent;
Begin
{MainOwner^.WinList[Num]:=Nil;}
MainOwner^.CurWin:=0
end;


Procedure TMywin.SetMyWinCommands;
var I:word;
Begin
if num=0 then exit;
DisableCommands([0..255]);
WinComSet:=[0..99]-
           [cmCut..cmClear,cmSave,cmSaveAs]+
           [cmReadAnn,cmReadCom,cmReadSnd,cmEditRun006,cmOptFile..cmOptPrefer,cmOptOpen..cmOptSaveAs];
if ButtonCount<>0 then Include(WinComSet,cmOptMouse);
if MColl^.Count> 0 then
begin
WinComset:=WinComset+
+[cmSave,cmSaveAs,cmMark..cmEditTransp,cmWriteCom,cmPlay,cmPlayAll,cmPlayOnScreen];
for i:=0 to pred(MColl^.Count)do if MColl^.AtMarked(i) then break;
if not((i=pred(MColl^.Count))and(not MColl^.AtMarked(i)))
  then wincomset:=wincomset+[cmCut,cmCopy,cmClear];
{if Modified then Include(wincomset,cmSave);}
end;{if MColl^...}
WinComSet:=wincomSet+[cmZoom..cmPrev,cmTile,cmCascade,cmClose,cmCloseAll];
if PointerEditCache<>Nil then Include(wincomset,cmPaste);

for i:=1 to 9 do if MainOwner^.winlist[i]=Nil then Break;
if(i=9)and(MainOwner^.winlist[i]<>Nil)then Exclude(WinComSet,cmOpen);

EnableCommands(WinComSet);
end;

{}


Constructor TInterior.Init;
Begin
Inherited Init(Bounds,HS,VS);
WinOwner:=WOwner;
MColl:=WOwner^.MColl;
GrowMode:=gfGrowHiX or gfGrowHiY;
SetLimit(IscrollstringX,MColl^.count+1);
EventMask:=EventMask or evMouseAuto;
End;


Procedure TInterior.HandleEvent;
var  MousePoint:TPoint;
     w:word;
Begin
Inherited HandleEvent(E);
if(E.What and(evMouseDown or evMouseAuto)<>0)then
if MouseInView(E.Where)then
begin
MakeLocal(E.Where,MousePoint);
if(MousePoint.Y-Delta.Y<=MColl^.Count)
                    then
                    begin
                    w:=WinOwner^.CurPart;
                    if(MousePoint.Y+Delta.Y<>w)then WinOwner^.CurrentPart(MousePoint.Y+Delta.Y);
                    if((E.Buttons and mbRightButton)<>0)then
                       begin
                       if not((MousePoint.Y+Delta.Y=w)
                               and((E.What and evMouseAuto)<>0))
                       then with WinOwner^ do markpart(Curpart,Curpart,true,XorSet);
                       end;
                    if(MousePoint.Y+Delta.Y=WinOwner^.CurPart)
                        then
                        if E.Double then
                        begin
                        if((E.Buttons and mbRightButton)<>0)then WinOwner^.CurPos:=0;
                        E.What:=evCommand;
                        E.Command:=cmPlay;
                        E.InfoPtr:=Nil
                        end
                    end
end;
End;

Procedure TInterior.Draw;
var k,n:word;
    a:byte;
    B:TDrawBuffer;
    Color:byte;
    s:string;
    FormatRec:record
              LnNum,tmp,trns,sz,pos:longint
              end;
Begin
if WinOwner^.Num=0 then exit;
if WinOwner^.curpart>(delta.y+size.y-1)then begin delta.y:=WinOwner^.curpart-size.y+1 end;
if WinOwner^.curpart<=delta.y then begin delta.y:=WinOwner^.curpart end;
{if not WinOwner^.Playing then begin
                    if HScrollBar<>Nil then HScrollBar^.DrawView;
                    if VScrollBar<>Nil then VScrollBar^.DrawView;
                    end;}
for n:=0 to pred(Size.Y) do
         begin
         k:=Delta.Y+n;
         a:=ord(MColl^.AtMarked(k));
         if winowner^.curpart<>k then Color:=Getcolor(1+3*a)
         else Color:=Getcolor(2+ord(WinOwner^.Playing)+3*a);
         MoveChar(B,' ',Color,size.x);
         if k<MColl^.count then begin
                                with FormatRec do begin
                                                  LnNum:=succ(k);
                                                  with WinOwner^ do
                                                  if (Playing)and(curpart=k)then
                                                     begin
                                                     tmp :=Cur8.save4[1];
                                                     trns:=Cur8.save4[2]div 2
                                                     end     else
                                                     begin
                                                     tmp :=Datptr(MColl^.At(k))^.Special.save4[1];
                                                     trns:=Datptr(MColl^.At(k))^.Special.save4[2]div 2
                                                     end;
                                                  sz  :=Datptr(MColl^.At(k))^.Datsize div 6;
                                                  if winowner^.curpart=k then Pos :=winowner^.CurPos div 6
                                                                         else pos:=0;
                                                  end;
                                formatstr(s,IscrollFormatStr,Formatrec);
                                movestr(b,copy(s,delta.x+1,size.x),Color)
                                end;
         writeline(0,N,size.x,1,B);
         end;
End;

Function TInterior.GetPalette:PPalette;
Begin
GetPalette:=@CMyScrollerPalette
end;

Function MySysError(ErrorCode:integer;Drive:Byte):Integer;
var s:string;
    DB:TDrawBuffer;
    Colors:word;
    ScrBuf:^TWordArray;
    I,J:word;
    L:Longint;
    Ch:byte;
Begin
case ErrorCode of
0 :s:=seDiskWriteProtected;
1 :s:=seCriticalDickError;
2 :s:=seDiskNotReady;
3 :s:=seCriticalError;
4 :s:=seDataError;
5 :s:=seCriticalDiskErr;
6 :s:=seSeekError;
7 :s:=seUnknownMedia;
8 :s:=seSectorNotFound;
9 :s:=sePrinterOutOfPaper;
10:s:=seWriteFault;
11:s:=seReadFault;
12:s:=seHardwareFailure;
13:s:=seBadMemoryImageOfFat;
14:s:=seDeviceAccessError;
15:s:=seInsertDiskette
else s:=seErrMsg;
end;
if ErrorCode in[0..8,10..12,15] then begin L:=Drive+65;FormatStr(s,s,L) end;
case AppPalette of
apBlackWhite,
apMonochrome:Colors:=SysMonoAttr
else Colors:=SysColorAttr;
end;
ScrBuf:=ScreenBuffer;
I:=ScreenWidth*(ScreenHeight-1);
for J:=0 to ScreenWidth do
     if J<length(s) then DB[J]:=(Lo(Colors)shl 8)+ord(s[j+1])
                    else DB[J]:=(Lo(Colors)shl 8)+$20;
for J:=1 to(sizeof(seRetryCancel)div sizeof(seRetryCancel[1]))do
           begin
           if seRetryCancel[j].A=0 then seRetryCancel[j].A:=Lo(Colors);
           if seRetryCancel[j].A=1 then seRetryCancel[j].A:=Hi(Colors)
           end;
move(seRetryCancel,DB[screenwidth-(sizeof(seRetryCancel)div
                                   sizeof(seRetryCancel[1]))-1],
                                   sizeof(seRetryCancel));
move(DB,ScrBuf^[i],screenWidth*2);
asm
@wait:
xor ax,ax
int 16h
cmp al,27
jz @cont
cmp al,13
jz  @cont
jmp @wait
@cont:
mov &Ch,al
end;
if Ch=13 then MySysError:=0
         else MySysError:=1;
End;
end.
