{$F+}
unit ruschar;
interface
var IsKeyPressed:boolean;
    EnableKBHandler:boolean;
    IsRus:Boolean;
Const BorderColor:byte=10;
Procedure InitRusChars;
Procedure DoneRusChars;
Function  IsKeyRus:boolean;
var CharTable:pointer;
implementation
uses Dos;
var HiResScreen:boolean;
    BPC:word;
    ScrRows:byte;
    SaveExit,Old1F:Pointer;
    IsText:boolean;
    Old9:Procedure;
const
  RusCharTable:array[0..255]of char=
  #0#1#2#3#4#5#6#7#8#9#10#11#12#13#14#15#16#17#18#19#20#21#22#23#24#25#26#27#28#29#30#31+
  +' !#$:.();+-/0123456789=?"\,_`㠯讫駩륣|~'+
  ''+
  +''+#255;

procedure SetCRTData;Assembler;
asm
      mov       ax,1130h
      mov       bh,0
      mov       dl,0
      mov       HiResScreen,1
      push      es
      push      bp
      int       10h
      pop       bp
      pop       es
      or        dl,dl
      jnz       @@1
      mov       dl,24
      mov       cx,8
      mov       HiResScreen,0
@@1:  inc       dl
      mov       scrrows,dl
      mov       BPC,cx
      mov       ax,0D00h
      mov       bh,0
      mov       cx,0
      mov       dx,0
      int       10h
      push      ax
      mov       ax,0C01h
      mov       bh,0
      mov       cx,0
      mov       dx,0
      int       10h
      mov       ax,0D00h
      mov       bh,0
      mov       cx,0
      mov       dx,0
      int       10h
      dec       al {AL = 1}
      jnz       @@2
      mov       IsText,0
      jmp       @@3
@@2:  mov       IsText,1
      pop       ax
      jmp       @@4
@@3:  pop       ax
      mov       ah,0Ch
      mov       bh,0
      mov       cx,0
      mov       dx,0
      int       10h
@@4:
end;

Function IsKeyRus:boolean;
var p:pointer;
begin
GetIntVec($1F,p);
IsKeyRus:=word(ptr(Seg(P^)-1,1)^)=seg(P^);
end;
{$L FONT16}
{$L FONT14}
{$L FONT8}

Procedure Font16;external;
Procedure Font14;external;
Procedure Font8;external;

Procedure LoadFont(fnt:pointer;BPC:byte);assembler;
asm
      cmp       [fnt].word[1],0
      jz        @end
      mov       ax,1100h
      mov       cx,100h
      xor       dx,dx
      mov       bl,0
      mov       bh,BPC
      push      bp
      les       bp,fnt
      int       10h
      pop       bp
@end:
end;

Procedure LoadGrFont(fnt:pointer;BPC:byte);assembler;
asm
      cmp       [fnt].word[1],0
      jz        @end
      mov       ax,1121h
      mov       ch,0
      mov       cl,BPC
      mov       bl,0
      xor       dx,dx
      cmp       scrrows,14
      jne       @@25
      mov       dx,1
      jmp       @@1
@@25: cmp       scrrows,25
      jne       @@43
      mov       dx,2
      jmp       @@1
@@43: cmp       scrrows,43
      jne       @@1
      mov       dx,3
@@1:  mov       bh,BPC
      push      bp
      les       bp,fnt
      int       10h
      pop       bp
@end:
end;

var b:boolean;
Procedure NewKBHnd;interrupt;assembler;
asm     mov        es,seg0040
        mov        di,es:[1Ch]
        mov        bh,es:[96h]
        and        bh,4
        mov        bl,es:[17h]
        and        bl,3
        pushf
        call       Old9
        mov        ds,Seg0040
        mov        si,96h
        lodsb
        test       al,10h
        jnz        @EnhKB
        mov        si,17h
        lodsb
        cmp        bl,3
        jne        @End
        and        al,3
        cmp        al,3
        je         @End
        jmp        @Switch
@EnhKB: and        al,4
        cmp        bh,4
        jne        @End
        cmp        al,0
        jne        @End
@Switch:mov        dx,seg @Data
        mov        ds,dx
        cmp        IsRus,0
        jne        @ToLat
        mov        al,1
        mov        IsRus,al
        Call       @Indic
        jmp        @@Q
@ToLat: mov        al,0
        mov        IsRus,al
        Call       @Indic
        jmp        @@Q
@End:   mov        dx,seg @Data
        mov        ds,dx
        cmp        IsRus,0
        je         @@Q
        mov        ds,Seg0040
        mov        si,1Ch
        mov        si,[si]
        cmp        si,di
        je         @@Q
        mov        ax,[di]
        mov        dx,seg @Data
        mov        ds,dx
        lds        bx,CharTable
        xlat
        mov        ds,seg0040
        mov        [di],al
        sub        al,224 { = ''}
        jnz        @NO224
        mov        [di+1],al { al = 0}
@NO224:
{        mov        dx,seg @Data
        mov        ds,dx}
        jmp        @@Q
@Indic: cmp        HiResScreen,0
        jnz        @EVA
        retn
@EVA:   or         al,al
        jz         @@3
        mov        bl,BorderColor
        jmp        @@4
@@3:    mov        bl,0
@@4:    mov        dx,3dah
        in         al,dx
        mov        al,11h
        mov        dx,3c0h
        out        dx,al
        mov        al,bl
        out        dx,al
        mov        al,32
        out        dx,al
        retn
@@Q:
        mov        IsKeyPressed,True
end;

Procedure InitRusChars;
var p,q:pointer;
begin
SetCRTData;
Case BPC of
16:p:=@Font16;
14:p:=@Font14;
else p:=@Font8
end;
if HiResScreen then if IsText then LoadFont(p,BPC)
                              else LoadGrFont(p,BPC);
GetIntVec($1F,q);
if p<>Nil then PChar(p):=PChar(p)+128*BPC;
if q<>p then Old1F:=q;
asm xor bx,bx;mov ax,0305h;int 16h end;
if EnableKBHandler then begin
                        GetIntVec($9,q);
                        if q<>@NewKBHnd then
                           begin
                           @Old9:=q;
                           SetIntVec(9,@NewKBHnd);
                           end;
                        if HiResScreen then
                                 asm
                                  mov        bl,0
                                  cmp        IsRus,0
                                  jz         @@1
                                  mov        bl,BorderColor
                             @@1: mov        dx,3dah
                                  in         al,dx
                                  mov        al,11h
                                  mov        dx,3c0h
                                  out        dx,al
                                  mov        al,bl
                                  out        dx,al
                                  mov        al,32
                                  out        dx,al
                                 end;
                        end;
if p<>nil then SetIntVec($1F,p);
end;

Procedure DoneRusChars;
begin
SetIntVec($1F,Old1F);
if @Old9<>Nil then begin SetIntVec(9,@Old9);@Old9:=Nil end;
if IsRus and HiResScreen then
asm mov bl,0;mov dx,3dah;in al,dx;mov al,11h;mov dx,3c0h{Restore boreder color}
    out dx,al;mov al,bl;out dx,al;mov al,32;out dx,al end;
end;

procedure MyExit;far;
begin
ExitProc:=SaveExit;
DoneRusChars;
end;

begin
EnableKBHandler:=False;
SaveExit:=ExitProc;
ExitProc:=@MyExit;
GetIntVec($1F,Old1F);
b:=False;IsKeyPressed:=False;IsRus:=False;
@Old9:=Nil;CharTable:=@RusCharTable;
if not IsKeyRus then InitRusChars;
end.