unit utils;
interface
type
nm=array[1..255] of string;
aob=array[1..65534]of byte;
boolfunc=function:boolean;
const
  {clock}
  hour=0;
  min=1;
  minute=1;
  sec=2;
  second=2;
  hundredth=3;
  hun=3;
  {time}
  full=1;
  brief=2;
  {String}
  integer_value='-1234567890+';
  word_value   ='+1234567890';
  real_value   ='-2.3456789E+01eE';
  file_name    ='ABCDEFGHIJKLMNOPQRSTUVWXYZ'+
                'abcdefghijklmnopqrstuvwxyz'+
                '1234567890-_!@#$&()\:[].''';
  allchars=
  #1#2#3#4#5#6#7#8#9#10#11#12#13#14#15#16#17#18#19#20#21#22#23#24#25#26#27#28#29#30#31+
  +' !"#$%&''()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~'+
  ''+
  +''+#255;
  anystring=' !"#$%&''()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~'+
  ''+
  +''+#255;
  hexdig:array[0..15] of char =('0','1','2','3','4','5','6','7','8','9',
                                'A','B','C','D','E','F');

  {Disk}
  Drive_Removable= $100;
  Drive_Remote   =$1000;
  Drive_Fixed    =$2000;
  Drive_Error    =$FFFF;

var cmdlnptr:^string;
    progname:string;
    CmdLine :string[127];
function  definebit(a:word;b:byte):boolean;{True if bit number 'b' in 'a' is 1}
function  longdefinebit(a:longint;b:byte):boolean;{Same for Long Integer}
function  BCDtoDec(bcd:byte):byte;{Converts BCD digit to decimal}
function  hexval(a:byte):string;
function  wordhexval(a:word):string;
function  longhexval(a:longint):string;
function  clock(n:byte):byte;
function  time(f:byte):string;
function  yes:boolean;
procedure reboot;{믮 砫 㧪}{Equivalent Ctrl-Alt-Del}
procedure restart; {믮 砫 㧪}{Equivalent Reset}
function  Is286Available: Boolean;
function  FileName(var F{:File,File of ...,Text}):string;
function  FileExist(s:string):boolean;
Procedure ChangeProc(OldProc,NewProc:Pointer);
Function  PPos(p:pchar;substr:string):word;

(***************SOUND PROCEDURES******************************)
procedure setsoundfreq(freq:word);{⠭  㪠}
procedure SoundOn;{砥 }
procedure SoundOff;{몫砥 }

(***************DISK PROCEDURES******************************)
procedure selectdrive(drname:char);
function getmaxdrive:char;
function getcurrentdrive:char;
function getdisknum:byte;
function validdrive(drname:char):boolean;
function getdrivetype(Id:word):integer;{Id: 0=Current; 1=A; 2=B etc.}

(*********STRING PROCEDURES**********************************)
const readstringattr:byte=7;
Function  ReadStringAs(Pattern:string;maxlen:byte;var str:string):boolean;
Function  ReadLongStringAs(Pattern:string;maxlen,maxplace:byte;var str:string):boolean;
{뢮 ப  樨   ࠭ page  ਡ⮬ atr
    ᤢ}
procedure outstring(str:string;atr,page:byte);
{뢮 ப  樨 x,y  ࠭ page  ਡ⮬ atr
    ᤢ}
procedure outstringxy(str:string;x,y,atr,page:byte);
{ॢ ᨬ  ப s  孨 ॣ}
procedure upstring_r(var s:string);
procedure upstring(var s:string);
{ ᨢ ப (⨯ nm)  䠢⭮ 浪}
procedure sortstring(a:byte;var star:array of string);
procedure addspace(var s:string;len:byte);

(*********TEXT PROCEDURES**********************************)
{뢮 count ᨬ ch  ਡ⮬ attr  樨 .
    ᤢ}
procedure printchar(ch:char;attr:byte;count:word);
{뢮 ப s  ਡ⮬ CRT.textattr  樨 x,y.
    ᤢ}
procedure writexy(x,y,attr:byte;s:string);
{  ࠬ  न⠬ x1,y1,x2,y2.V  H 㪠뢠 ⭮ 
    ⨪  ਧ⠫..祭. h  v:0,1,2}
procedure drawborder(H,V,atr,x1,y1,x2,y2:byte);
{⠭ ࠧ  (using BIOS)}
procedure SetCurSize(topline,botline:byte);
{⠭  ப ᪠஢  (using direct access to Motorola)}
procedure SetCursorTopLine(topline:byte);
{頥  ⥪饩 ࠭}
Function GetPage:byte;
{ॢ   ࠭ page   x,y}
Procedure MoveCursorTo(x,y,page:byte);
{ॢ   ⥪饩 ࠭   x,y}
Procedure absgotoxy(x,y:byte);
{頥 न   x,y ;
    ࠧ  top,bot( scan line )  ࠭ page}
Procedure Getcursor(var x,y,top,bot:byte;page:byte);
{頥     ⥪饩 ࠭ }
Function abswherex:byte;
{頥  ப   ⥪饩 ࠭ }
Function abswherey:byte;
{頥 ࠭  ⥪ ࠭ ஡  ਡ⮬ TextAttr}
procedure clrALLscr(textattr:byte);
{頥   ࠭,  ஡  ਡ⮬ TextAttr}
procedure clrrgn(x1,y1,x2,y2,textattr:byte);
{  ࠭   न⠬ x1,y1,x2,y2,梥⮬ ⥪ Lo(Attrs),
  ࠬ 梥 Hi(Attrs),뢮  Hdr,
뢮   ⥪ MsgText. ᫨ ப  頥,   १.
 #13 -  砫 ப,#10 - 室  .
㭪   StopProc ୥ True  ⥬ 㭨⮦ }
function textmessage(x1,y1,x2,y2,Bord,Attrs:word;hdr,MsgText:string;stopproc:boolfunc):boolean;
{४砥  ⥭ᨢ/}
Procedure Blinking(b:wordbool);
const EGAcharblock:byte=0;
{頥  ᨬ  charht 
   ᨬ쭮 ᫮ ப  ࠭ (   0)}
{WARNIING : Next three procedures work on EGA/VGA video card only,
            but this procedures make no checking}
procedure getEGAchar(var charht,maxrow:word);
{⠭ 㢥祭 ᫮ ப EGA/VGA}
procedure EGAlines;
{⠭ ଠ쭮 - ப}
procedure Lines25;



implementation
uses dos;

type textscreenbuffer=array[1..2000]of record
                                           chr:char;
                                           attr:byte
                                           end;
fulltextscreenbuffer=array[1..14000]of record
                                           chr:char;
                                           attr:byte
                                           end;

var textvbuffer:^textscreenbuffer;
    regs:registers;

const wordset=['0'..'9','a'..'z','A'..'Z',''..'',''..'',''..'','',''];


function definebit(a:word;b:byte):boolean;assembler;
asm
mov ax,1
mov cl,b
shl ax,cl
mov bx,ax
mov ax,a
and ax,bx
shr ax,cl
end;

function longdefinebit(a:longint;b:byte):boolean;
 var x,y:longint;z:byte;
     w:real;
 begin
 x:=a;z:=b+1;
 repeat
 y:=x mod 2;
 x:=x div 2;
 dec(z);
 until z=0;
 if y=1 then longdefinebit:=true else longdefinebit:=false;
end;

function Is286Available: Boolean;assembler;
asm
        PUSHF
        POP     BX
        AND     BX,0FFFH
        PUSH    BX
        POPF
        PUSHF
        POP     BX
        AND     BX,0F000H
        CMP     BX,0F000H
        MOV     AX,0
        JZ      @@1
        MOV     AX,1
@@1:
end;

Function FileName(var F):string;
var a:aob absolute F;
    I:word;
    s:string;
Begin
I:=49;
if a[4]<>$D7 then{File not assigned} exit;
s:='';
while a[i]<>0 do begin s:=s+char(a[i]);inc(i) end;
FileName:=s;
end;

Function FileExist(S:String):boolean;
var F:File;
    I:byte;
Begin
FileExist:=False;
if s='' then exit;
{$I-}
Assign(f,s);
I:=FileMode;
FileMode:=0;
reset(f,1);
close(f);
FileMode:=i;
FileExist:=Ioresult=0
end;


Function  PPos(p:pchar;substr:string):word;assembler;
asm
push    ds
mov     ds,[bp+8]
mov     si,[bp+6]
mov     es,[bp+12]
mov     di,[bp+10]
mov     cl,[si]{cl = Substr length}
xor     ch,ch

{jcxz    @done}
cld
push    di
push    cx
mov     cx,0FFFFh
xor     ax,ax
repne   scasb
mov     bx,cx
not     bx{BX=lenght P + 1}
dec     bx
mov     ax,bx
pop     cx
pop     di
jcxz    @done{substr length =0}
cmp     cx,bx
ja      @done{substr longer than p}


inc     si
push    bx
cld
@next:
push    cx
push    di
push    si
inc     cx
repe    cmpsb
jcxz    @found

pop     si
pop     di
pop     cx
inc     di
dec     bx
cmp     bx,cx
ja      @next
pop     ax
jmp     @Done
@found:
pop     si
pop     di
pop     cx
pop     ax
sub     ax,bx
{inc     ax}
@done:

pop ds
end;

Procedure ChangeProc(OldProc,NewProc:pointer);Assembler;
Asm
mov ax,[bp+12]
{$IFNDEF MSDOS}
add ax,SelectorInc
mov es,ax
{$ELSE}
mov es,ax
{$ENDIF}
cld
mov di,[bp+10]
mov al,0EAh
stosb
mov ax,[bp+6]
stosw
mov ax,[bp+8]
stosw
End;

function BCDtodec(bcd:byte):byte;
begin
BCDtodec:=((bcd shr 4)*10)+(bcd and 15);
end;


function hexval(a:byte):string;
begin
hexval:=hexdig[(a) shr 4]+hexdig[(a) and 15];
end;


function wordhexval(a:word):string;
begin
wordhexval:=hexdig[hi(a) shr 4]+hexdig[hi(a) and 15]+hexdig[lo(a) shr 4]+hexdig[lo(a) and 15];
end;


function Longhexval(a:longint):string;
var b:array[0..4]of byte;
    s:string[8];
    s1:array[0..8]of byte absolute s;
begin
move(a,b,4);
s[0]:=#0;
for b[4]:=1 to 4 do begin s:=s+char(b[4-b[4]] shr 4);s:=s+char(b[4-b[4]] and 15) end;
for b[4]:=1 to 8 do s[b[4]]:=hexdig[s1[b[4]]];
longhexval:=s
end;


function yes:boolean;assembler;
asm
@beg:
mov ah,00
int 16h
cmp ah,21
je @yes
cmp ah,49
je @no
jmp @beg
@yes:
mov al,1
jmp @exit
@no:
mov al,0
@exit:
end;



function clock(n:byte):byte;
begin
regs.ah:=$2C;
MsDos(regs);
with regs do
case n of
0:clock:=ch;
1:clock:=cl;
2:clock:=dh;
3:clock:=dl;
 else clock:=0;
end;
end;
function time(f:byte):string;
var
a,b,c:string[3];
begin
str(clock(0):2,a);
str(clock(1):2,b);
str(clock(2):2,c);
case f of
1: time:=a+':'+b+':'+c;
2: time:= a+':'+ b;
3: time:= b+':'+ c;
 else time:='Error in parameters!';
 end;
 end;

procedure SoundOn;assembler;
asm
mov dx,97
in  al,dx
or  al,3
OUT dx,AL
end;

procedure SoundOff;assembler;
asm
mov dx,97
in  al,dx
and al,11111100b
out dx,al
end;

procedure setsoundfreq(freq:word);
const standfreq=1193180;
var
longcount:longint;
count:word;
begin
if freq=0 then soundoff;
if freq<=18 then freq:=19;
count:=standfreq div freq;
asm
MOV AL,182
OUT 67,AL
MOV AX,count
OUT 66,AL
MOV AL,AH
OUT 66,AL
end
end;


procedure selectdrive(drname:Char);assembler;
asm
MOV AL,drname
cmp AL,'A'
jl @Exit
cmp AL,'z'
jg @Exit
cmp al,'Z'
jng @chdr
@Lo2Up:
cmp al,'a'
jl @Exit
and al,223
@CHDR:
sub al,'A'
mov dl,al
xor ax,ax
MOV AH,0Eh
INT 33               {;   DOS   15( )}
@Exit:
end;

function getcurrentdrive:char;assembler;
asm
MOV AH,19h
MOV AL,3
INT 33
add al,'A'
end;

function getmaxdrive:char;assembler;
asm
call getcurrentdrive
xor ah,ah
push ax
mov ax,0FFh
@next:
push ax
push ax
call selectdrive
call getcurrentdrive
pop bx
xor ah,ah
cmp ax,bx
jz @exit{Found last drive}
mov ax,bx
dec ax;{Test next drive}
jz @exit{Error : AX=0}
jmp @next

@exit:
pop bx
push ax
push bx
call selectdrive
pop ax
end;

function GETDISKNUM:byte;assembler;
asm
MOV AH,08h
INT 13h
MOV AL,DL
end;

function validdrive(drname:char):boolean;assembler;
asm
call getcurrentdrive
xor ah,ah
push ax
mov al,drname
push ax
push ax
call selectdrive
call getcurrentdrive
pop bx
xor ah,ah
cmp ax,bx
mov al,True
jz @exit{Valid drive}
dec ax;{Invalid drive}

@exit:
pop bx
push ax
push bx
call selectdrive
pop ax
end;

Function getdrivetype;assembler;
asm
mov      ax,4408h
mov      bx,Id
int      21h
cmp      al,0Fh
jz       @Err
or       ax,ax
mov      ax,Drive_Removable
jz       @@Q
mov      ax,4409h
mov      bx,Id
int      21h
jc       @Err
mov      ax,dx
and      ax,1000h
jnz      @@Q
mov      ax,Drive_Fixed
jmp      @@Q
@Err:
mov      ax,Drive_Error
@@Q:
end;

procedure reboot;assembler;
asm
mov ax,seg0040
mov ds,ax
mov word ptr [72h],1234h
db 0EAh
dw 00000h
dw 0FFFFh
{JMP FAR FFFF:0000}
{
mov ax,$F000
push ax
mov ax,$FFF0
push ax
retf}
end;

procedure restart;assembler;
asm
mov ax,seg0040
mov ds,ax
mov word ptr [72h],0000h
db 0EAh
dw 00000h
dw 0FFFFh
{JMP FAR FFFF:0000}
end;


Function ReadStringAs(Pattern:string;maxlen:byte;var str:string):boolean;
var sc:byte;
    loc,loc1:byte;
    page:byte;
    ix,iy:byte;

function getchar:char;
begin
regs.ah:=0;
intr($16,regs);
Getchar:=chr(regs.al);
sc:=regs.ah;
end;

procedure outchar(ch:char);
begin
regs.ah:=9;
regs.al:=ord(ch);
regs.bh:=page;
regs.bl:=readstringattr;
regs.cx:=1;
intr($10,regs);
end;

var ok,cancel:boolean;
    i:byte;
    ch:char;
    S,s1:string;
    insflag:boolean;
    it,ib:byte;
const
    b1:byte=1;
    b2:byte=1;
begin
page:=byte(ptr(seg0040,$62)^);
getcursor(ix,iy,it,ib,page);
{ix:=wherex;
iy:=wherey;}
ok:=false;
cancel:=false;
insflag:=true;
if maxlen>=length(str) then s:=str
else s:=copy(str,1,maxlen-1);
loc:=length(s)+1;
b1:=1;
if ix>b1 then b1:=ix;
{b2:=lo(windmax)+2;}
asm mov ah,0Fh;int 10h;mov b2,ah end;
if (b2=15)or(b2=0)then b2:=mem[Seg0040:$4A];
if (b2-b1)>maxlen then b2:=b1+maxlen;
for i:=1 to length(s) do begin
                         outchar(s[i]);
                         if ix+i<=b2 then absgotoxy(ix+i,iy)
                         end;
outchar(#32);
repeat
ch:=getchar;
loc1:=loc;
s1:=s;
if(ch<>#0)then
for i:=1 to length(pattern) do if(pattern[i]=ch)and((length(s)+1<(b2-b1))
                                   or((loc<(b2-b1))and not insflag))then
                                                     begin
                                                     if(insflag)or(loc>length(s))then
                                                     insert(ch,s,loc)
                                                     else s[loc]:=ch;
                                                     inc(loc);
                                                     end;

case sc of
75:if loc>1 then dec(loc);
77:
   if loc<=length(s)then inc(loc);
71:loc:=1;
79:loc:=length(s)+1;
14:if loc in[2..length(s)+1] then begin delete(s,loc-1,1);dec(loc)end;
82:begin
   insflag:=not insflag;
   if insflag then setcursize(it,ib) else setcursize(0,ib);
   end;
83:if loc in[1..length(s)] then delete(s,loc,1);
1:begin cancel:=true;if (s[loc-1]=#27) and (ch=#27) then delete(s,loc-1,1) end;
28:begin ok:=true;if (s[loc-1]=#13) and (ch=#13) then delete(s,loc-1,1) end;
end;
if (s=s1)and(loc=loc1)then continue;
if (loc<>loc1)and(s=s1) then
                  begin
                  absgotoxy(ix+loc-1,iy);
                  continue;
                  end;
absgotoxy(ix,iy);
for i:=1 to length(s) do begin
                         outchar(s[i]);
                         if ix+i<=b2 then absgotoxy(ix+i,iy)
                         end;
outchar(#32);
if ix+loc<=b2 then absgotoxy(ix+loc-1,iy);
until ok or cancel;
setcursize(it,ib);
if ok then
str:=s;
ReadStringAs:=ok;
end;

procedure outstring(str:string;atr,page:byte);assembler;
asm
push ds;        push es;        push di;        push si
mov es,seg0040; mov di,50h;     mov al,page;    xor ah,ah
shl ax,1;       add di,ax;      mov bx,es:[di]  {BL = cursor column,BH = cursor row}

cmp byte ptr es:[49h],7; je  @mono
cmp byte ptr es:[49h],3; ja  @exit

@color:
mov es,segb800; jmp @ok
@mono:
mov es,segb000;
@ok:
cld
mov cl,11;      shl ax,cl       {AX = page * 4096}
mov ds,[bp+12]; mov si,[bp+10]
mov cl,ds:[si]  {String length -> CL}
xor ch,ch;      jcxz @exit      {Empty string}
                                { ES=$B800 }
mov di,0;       add di,ax{ES:DI points to beginning of the videopage}
mov dl,bh;      xor dh,dh;      mov ax,80*2
mul dl;         mov dl,bl;      shl dx,1;       add ax,dx
add di,ax                       {ES:DI points to the current cursor position}
inc si;         mov dx,ss:[bp+8]{DL = TEXT ATTR}
mov ah,dl
@next:
lodsb;          stosw
loop @next      {NEXT SYMBOL}
@exit:
pop si;         pop di;         pop es;         pop ds
end;


procedure outstringxy(str:string;x,y,atr,page:byte);assembler;
asm
push ds;        push es;        push di;        push si;
mov al,page;    xor ah,ah
mov bl,x;       mov bh,y                         {BL = cursor column,BH = cursor row}
dec bl;         dec bh
mov es,seg0040
cmp byte ptr es:[49h],7; je  @mono
cmp byte ptr es:[49h],3; ja  @exit

@color:
mov es,segb800; jmp @ok
@mono:
mov es,segb000;
@ok:
cld

mov cl,11;      shl ax,cl        {AX = page * 4096}
mov ds,[bp+16]; mov si,[bp+14]
mov cl,ds:[si];                                    {String length -> CL}
xor ch,ch;      jcxz @exit                         {Empty string}
                                                   { ES=$B800 }
mov di,0;       add di,ax                          {ES:DI points to beginning of the videopage}
mov dl,bh;      xor dh,dh;      mov ax,80*2;       mul dl
mov dl,bl;      shl dx,1;       add ax,dx
add di,ax                                          {ES:DI points to the current cursor position}
inc si;         mov dl,atr                  {DL = TEXT ATTR}
mov ah,dl
@next:
lodsb;          stosw
loop @next{NEXT SYMBOL}
@exit:
pop si;         pop di;         pop es;            pop ds
end;

procedure addspace(var s:string;len:byte);
begin
fillchar(s[succ(length(s))],len-length(s),#32);
s[0]:=char(len);
end;

Function ReadLongStringAs(Pattern:string;maxlen,maxplace:byte;var str:string):boolean;{?!?}
var s,s1,s2:string;
    sc:byte;
    lb,rb,
    loc,loc1,
    page,
    ix,iy,it,ib,
    i,b1,b2:byte;
    ok,cancel,insflag:boolean;
    ch:char;
    reg:byte;
    DirectVideo:boolean;
function getchar:char;
begin
regs.ah:=0;
intr($16,regs);
Getchar:=chr(regs.al);
sc:=regs.ah;
end;

procedure outchar(ch:char;atr,page:byte);
begin
regs.ah:=9;
regs.al:=ord(ch);
regs.bh:=page;
regs.bl:=atr;
regs.cx:=1;
intr($10,regs);
absgotoxy(abswherex+1,abswherey);
end;

procedure outstring1(var str:string;atr,page:byte);
var i:byte;
begin
for i:=1 to length(str) do outchar(str[i],atr,page);
end;

BEGIN
if (maxplace=0)or(maxlen=0)then exit;
page:=byte(ptr(seg0040,$62)^);
getcursor(ix,iy,it,ib,page);
{ix:=wherex;
iy:=wherey;}
ok:=false;
cancel:=false;
if maxlen>=length(str) then s:=str
 else s:=copy(str,1,maxlen);
loc:=1;
b1:=1;
if ix>b1 then b1:=ix;
{b2:=lo(windmax)+2;}
asm mov ah,0Fh;int 10h;mov b2,ah;mov reg,al end;
if (b2=15)or(b2=0)then b2:=mem[Seg0040:$4A];
if (b2-b1)>maxplace then b2:=b1+maxplace-1;
DirectVideo:=reg in[0..3];
maxplace:=b2-b1+1;
lb:=1;
rb:=b2-b1+1;
if rb>length(s) then rb:=length(s);
s1:=copy(s,loc,rb-lb+1);
addspace(s1,maxplace);
if directvideo then outstring(s1,readstringattr,page)
               else begin
                    outstring1(s1,readstringattr,page);
                    absgotoxy(ix,iy);
                    end;
repeat
ch:=getchar;
loc1:=loc;
s2:=s;
if (ch<>#0) then
for i:=1 to length(pattern) do if(pattern[i]=ch)and((length(s)<maxlen)
                                   or((loc<=maxlen)and not insflag))
                                  then
                                  begin
                                  if(insflag)or(loc>length(s))then
                                  insert(ch,s,loc)
                                  else s[loc]:=ch;
                                  inc(loc);
                                  end;

case sc of
 75:if loc>1 then dec(loc);

 77:if loc<=length(s)then inc(loc);

 71:loc:=1;

 79:loc:=length(s)+1;
 14:if loc in[2..length(s)+1] then
     begin
     if s[loc-1]=#8 then begin  delete(s,loc-1,1);dec(loc);
     if lb>1 then begin
     dec(lb);dec(rb) end;end;
     if loc in[2..length(s)+1] then
     begin
     delete(s,loc-1,1);dec(loc);
     if lb>1 then begin
     dec(lb);dec(rb) end;
     end;
     if ch=#127 then begin
                     i:=loc;
                     if i>1 then
                     begin
                     if (i>1)and not(s[i-1] in wordset) then dec(i);
                     while (i>1)and(s[i-1] in wordset)do dec(i);
                     while (i>1)and not(s[i] in wordset) do dec(i);
                     while (i>1)and(s[i-1] in wordset) do dec(i);
                     end;
                     if i<>loc then begin delete(s,i,loc-i);loc:=i end
                     end
     end;
 82:begin
    insflag:=not insflag;
    if insflag then setcursize(it,ib) else setcursize(0,ib);
    end;

 83:if loc in[1..length(s)] then delete(s,loc,1);
115:if loc>1 then
    begin
    if (loc>1)and not(s[loc-1] in wordset) then dec(loc);
    while (loc>1)and(s[loc-1] in wordset)do dec(loc);
    while (loc>1)and not(s[loc] in wordset) do dec(loc);
    while (loc>1)and(s[loc-1] in wordset) do dec(loc);
    end;
116:if loc<length(s)then
    begin
    while (loc<=length(s))and(s[loc+1] in wordset)do inc(loc);
    if (loc<=length(s))and not(s[loc+1] in wordset) then inc(loc);
    while (loc<=length(s))and not(s[loc] in wordset) do inc(loc);
    end;
117:loc:=rb;
119:loc:=lb;
1:begin cancel:=true;if (s[loc-1]=#27) and (ch=#27) then delete(s,loc-1,1) end;
28:begin ok:=true;if (s[loc-1]=#13) and (ch=#13) then delete(s,loc-1,1) end;
end;

if (s2=s)and(loc=loc1)then continue;{Nothing has been changed}

if loc<lb then begin lb:=loc;rb:=lb+maxplace-1;end;
if (loc>rb)and(rb-lb=pred(maxplace)) then begin rb:=loc;lb:=rb-maxplace+1 end;
if (loc>rb) then inc(rb);
if (rb<maxplace)and(rb<length(s))then rb:=length(s);
s1:=copy(s,lb,rb-lb+1);
addspace(s1,maxplace);
{if rb>length(s) then s1:=s1+' ';}
absgotoxy(ix,iy);
if (s<>s2)or(loc=lb)or(loc=rb)then
if directvideo then outstring(s1,readstringattr,page)
               else outstring1(s1,readstringattr,page);
absgotoxy(b1+loc-lb,iy);
until ok or cancel;
setcursize(it,ib);
if ok then str:=s;
ReadLongStringAs:=ok;
END;



procedure upstring_r(var s:string);assembler;
asm
{$IFOPT P+}
       mov  es,[bp+10]
       mov  di,[bp+8]
{$ELSE}
       mov  es,[bp+8]
       mov  di,[bp+6]
{$ENDIF}
       mov  cl,es:[di]{ ப  CX}
       xor  ch,ch
       or   cx,cx
       jz   @exit
       inc  di {ES:DI 㪠.   ᨬ ப}
       cld  { ।}
@next: mov  al,es:[di]
       cmp  al,'a'
       jb   @cont
       cmp  al,''
       ja   @cont
       cmp  al,'z'
       ja   @rus1 {. 㪢}
       and  al,223{a..z -> A..Z}
       jmp  @cont { ᫥. ᨬ}
@rus1: cmp  al,''
       ja   @rus2
       and  al,0CFh
       jmp  @cont
@rus2: cmp  al,''{  . ᨬ}
       jb   @cont
       xor  al,70h
@cont: stosb
       loop @next
@exit:
end;

procedure upstring(var s:string);assembler;
asm
{$IFOPT P+}
       mov  es,[bp+10]
       mov  di,[bp+8]
{$ELSE}
       mov  es,[bp+8]
       mov  di,[bp+6]
{$ENDIF}
       mov  cl,es:[di]{ ப  CX}
       xor  ch,ch
       or   cx,cx
       jz   @exit
       inc  di {ES:DI 㪠.   ᨬ ப}
       cld  { ।}
@next: mov  al,es:[di]
       cmp  al,'a'
       jb   @cont
       cmp  al,'z'
       ja   @cont
       and  al,223{a..z -> A..Z}
@cont: stosb
       loop @next
@exit:
end;

procedure sortstring(a:byte;var star:array of string);
var i,j,k:byte;
s:string;
done:boolean;
begin
 if a<=1 then exit;
 K:=a;
 if a>High(star) then k:=High(star);
 done:=false;
 while not done do
            begin
            for I:=1 to k do
              begin
                J:=1;
                if star[i]='' then continue;
		while(star[i][j]=star[i+1][j])and(j<high(star[i]))and(j<high(star[i+1]))do inc(j);
                if ord(star[i][j])>ord(star[i+1][j]) then
		    begin s:=star[i];
		          star[i]:=star[i+1];
                          star[i+1]:=s
                    end
              end;
             dec(k);
             done:=(k=1);
            end;
end;



procedure printchar(ch:char;attr:byte;count:word);
var p,x,y:byte;
    c:word;
begin
p:=mem[Seg0040:$62];{ ⥪饩 ࠭  p }
x:=mem[Seg0040:$50+(p*2)];
y:=mem[Seg0040:$51+(p*2)];
for c:=(Y*(memw[Seg0040:$4A]))+x to (Y*(memw[Seg0040:$4A]))+x+count-1 do
 begin
  mem[SegB800:c*2]:=ord(ch);
  mem[SegB800:(c*2)+1]:=attr
 end;
mem[Seg0040:$50+(p*2)]:=((mem[Seg0040:$50+(p*2)]+count)mod memw[Seg0040:$4A]);
mem[Seg0040:$51+(p*2)]:=((mem[Seg0040:$50+(p*2)]+count)div memw[Seg0040:$4A])+mem[Seg0040:$51+(p*2)]
end;

procedure writexy(x,y,attr:byte;s:string);
var page:byte;
begin
page:=mem[Seg0040:$62];{ ⥪饩 ࠭  p }
outstringxy(s,x,y,attr,page);
end;


procedure drawborder(H,V,atr,x1,y1,x2,y2:byte);
type dr_br=array[0..2,0..2] of char;
const L_T:DR_BR=((#0,#0,#0),
                 (#0,#218,#214),
                 (#0,#213,#201));
      L_B:DR_BR=((#0,#0,#0),
                 (#0,#192,#211),
                 (#0,#212,#200));
      R_T:DR_BR=((#0,#0,#0),
                 (#0,#191,#183),
                 (#0,#184,#187));
      R_B:DR_BR=((#0,#0,#0),
                 (#0,#217,#189),
      	         (#0,#190,#188));
      HLN:array[0..2]of char =(#0,#196,#205);
      VLN:array[0..2]of char =(#0,#179,#186);
var
      i:byte;
      mrow:byte;
begin
Mrow:=mem[Seg0040:$4A];
I:=mem[Seg0040:$62];{ ⥪饩 ࠭  p }
textvbuffer:=ptr(SegB800,i shl 12);

if not((x1 in [1..mrow])and(x2 in [1..mrow])and(y1 in [1..25])and(y2 in [1..25])
        and(h in [0..2])and(v in [0..2])) then exit;
if x1>x2 then begin i:=x1;x1:=x2;x2:=i end;
if y1>y2 then begin i:=y1;y1:=y2;y2:=i end;

for i:=x1 to x2 do with textvbuffer^[i+(y1-1)*mrow] do
                        begin
                        chr:=HLN[h];
                        attr:=atr
                        end;
for i:=x1 to x2 do with textvbuffer^[i+(y2-1)*mrow] do
                        begin
                        chr:=HLN[h];
                        attr:=atr
                        end;
for i:=y1 to y2 do with textvbuffer^[x1+(i-1)*mrow] do
                        begin
                        chr:=VLN[v];
                        attr:=atr
                        end;
for i:=y1 to y2 do with textvbuffer^[x2+(i-1)*mrow] do
                        begin
                        chr:=VLN[v];
                        attr:=atr
                        end;
textvbuffer^[x1+(y1-1)*mrow].chr:=L_T[h,v];
textvbuffer^[x2+(y1-1)*mrow].chr:=R_T[h,v];
textvbuffer^[x1+(y2-1)*mrow].chr:=L_B[h,v];
textvbuffer^[x2+(y2-1)*mrow].chr:=R_B[h,v];
end;

Procedure ClrALLscr(textattr:byte);
begin
asm
mov ax,seg0040
push ds
mov ds,ax
mov dl,[62h]
mov ax,[4Ah]
mov cl,[84h]
pop ds
inc cl{ CL = rows on EGA/MCGA/VGA screen}
mul cl
push ax
mov al,dl
xor ah,ah
mov cl,12
shl ax,cl
pop cx
mov es,SegB800
mov di,ax
mov al,20h {Fill with space (#32) }
mov ah,textattr { CRT unit}
rep stosw { Fill text video buffer}
end;
absgotoxy(1,1);
end;

function textmessage(x1,y1,x2,y2,bord,attrs:word;hdr,msgtext:string;stopproc:boolfunc):boolean;
var p:^aob;
    L:longint;
    i,j,k:byte;
    columns,pg:byte;
    hl:byte absolute hdr;
    ml:byte absolute msgtext;
Begin
textmessage:=false;
asm mov ah,0fh;int 10h; mov columns,ah;mov pg,bh end;
if(x1>x2)or(y1>y2)then exit;
L:=maxavail;
if l<(y2-y1+1)*(x2-x1+1)*2 then exit;
getmem(p,(y2-y1+1)*(x2-x1+1)*2);
for i:=1 to y2-y1+1 do
   move(mem[segB800:((y1+i-2)*columns+x1-1)*2],p^[2*(i-1)*(x2-x1+1)+1],2*(x2-x1+1));
clrrgn(x1,y1,x2,y2,hi(attrs));
drawborder(bord,bord,hi(attrs),x1,y1,x2,y2);
i:=length(hdr);
j:=x2-x1+1;
if hl>j then hl:=j;
outstringxy(hdr,x1+(j-hl)div 2,y1,hi(attrs),pg);
repeat
j:=y1+1;
k:=x1+1;
for i:=1 to ml do
case msgtext[i] of
#13:k:=x1+1;
#10:inc(j)
else begin if(k<x2)and(j<y2)then outstringxy(msgtext[i],k,j,lo(attrs),pg);
           inc(k)
     end;
end;
until stopproc;
for i:=1 to y2-y1+1 do
   move(p^[2*(i-1)*(x2-x1+1)+1],mem[segB800:((y1+i-2)*columns+x1-1)*2],2*(x2-x1+1));
freemem(p,(y2-y1+1)*(x2-x1+1)*2);
End;


Procedure Clrrgn(x1,y1,x2,y2,textattr:byte);assembler;
asm
mov  al,x1
cmp  al,x2
ja  @end
cmp  x1,0
jz   @end
cmp  x2,0
jz   @end
mov  al,y1
cmp  al,y2
ja  @end
cmp  y1,0
jz   @end
cmp  y2,0
jz   @end


mov  ah,0Fh
int  10h
{AH = columns,BH=Page}

xchg   al,ah
mov    ah,0
mov    bl,0
xchg   bl,bh

shl    ax,1
mov    dx,ax{DX = 2 * Columns}
mov    cl,y1
dec    cl
mul    cl
push   ax
mov    al,bl
xor    ah,ah
mov    cl,12
shl    ax,cl

mov    es,SegB800
mov    di,ax
pop    ax
add    di,ax
mov    al,x1
mov    ah,0
dec    ax
shl    ax,1
add    di,ax

mov    al,x1
mov    cl,x2
sub    cl,al
inc    cl
mov    ch,0

mov    bl,y2
mov    al,y1
sub    bl,al
inc    bl
mov    bh,0
mov    ah,textattr
mov    al,20h
@next:
push   cx
push   di
rep    stosw
pop    di
add    di,dx{Next row}
pop    cx
dec    bx
jnz    @next

@end:
end;


Procedure setcursize(topline,botline:byte);assembler;
asm
mov ch,topline
and ch,63
mov cl,botline
and cl,31
mov ax,seg0040
push ds
mov ds,ax
mov al,[49h]
pop ds
mov ah,01
int 10h
end;

Procedure setcursortopline(topline:byte);assembler;
asm
   MOV  DX,3D4H
   MOV  AL,10
   OUT  DX,AL
   INC  DX
   MOV  AL,topline
   OUT  DX,AL
end;

Function GetPage:byte;
Begin
With regs do begin
             AH:=$0F;
             DS:=DSEG;
             ES:=DSEG;
             intr($10,regs);
             GetPage:=bh;
             end
end;

procedure MoveCursorTo(x,y,page:byte);assembler;
asm
mov bh,page
mov dl,x
dec dl
js @exit
mov dh,y
dec dh
js @exit
mov ah,02
int 10h
@exit:
end;

Procedure absgotoxy(x,y:byte);
begin
movecursorto(x,y,mem[Seg0040:$62])
end;

Procedure Getcursor(var x,y,top,bot:byte;page:byte);assembler;
asm
mov bh,page
mov ah,03
int 10h

push ds
mov ax,[bp+22]
mov ds,ax
mov bx,[bp+20]
inc dl
mov [bx],dl{ DS:[BX] -> x }

mov ax,[bp+18]
mov ds,ax
mov bx,[bp+16]
inc dh
mov [bx],dh{ DS:[BX] -> y }

mov ax,[bp+14]
mov ds,ax
mov bx,[bp+12]
mov [bx],ch{ DS:[BX] -> top }

mov ax,[bp+10]
mov ds,ax
mov bx,[bp+8]
mov [bx],cl{ DS:[BX] -> bot }
pop ds
end;

Function absWherex:byte;
var a,b,c,d:byte;
begin
Getcursor(a,b,c,d,mem[Seg0040:$62]);
abswherex:=a;
end;

Function absWherey:byte;
var a,b,c,d:byte;
begin
Getcursor(a,b,c,d,mem[Seg0040:$62]);
abswherey:=b;
end;

Procedure Blinking(b:wordbool);assembler;
asm
mov ax,1003h
mov bx,b
or bx,bx
jz @set
mov bx,1
@set:
int 10h
end;


procedure getEGAchar(var charht,maxrow:word);
begin
with regs do begin
             ax:=$1130;
             bh:=$00;
             intr($10,regs);
             charht:=cx;
             maxrow:=dl;
             end;
end;

procedure EGAlines;
begin
with regs do begin
            ah:=$11;
            al:=$12;
            bl:=EGAcharblock;
            end;
intr($10,regs);
end;

procedure lines25;
var a,b:word;
    l:byte;
begin
getEGAchar(a,b);
case b of
42:l:=$11;
49:l:=$14
else exit;
end;
with regs do begin
            ah:=$11;
            al:=l;
            bl:=EGAcharblock;
            end;
intr($10,regs);
end;


var i:byte;
    k,n:word;
begin
n:=word(ptr(prefixseg,$2C)^);
cmdlnptr:=ptr(n,0);
{$B-}
for k:=0 to 500 do if(cmdlnptr^[k]=#0)and(cmdlnptr^[k+1]=#0)then break;
if k=500 then progname:='' else
begin
n:=k+3;
repeat inc(n);progname[n-k-3]:=cmdlnptr^[n] until cmdlnptr^[n]=#0;
progname[0]:=char(lo(n-k-4));
end;
cmdlnptr:=ptr(prefixseg,128);
Cmdline:=Cmdlnptr^;
end.
